# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'GetFoundationHypervisorIsosResult',
    'AwaitableGetFoundationHypervisorIsosResult',
    'get_foundation_hypervisor_isos',
]

@pulumi.output_type
class GetFoundationHypervisorIsosResult:
    """
    A collection of values returned by getFoundationHypervisorIsos.
    """
    def __init__(__self__, esxes=None, hypervs=None, id=None, kvms=None, linuxes=None, xens=None):
        if esxes and not isinstance(esxes, list):
            raise TypeError("Expected argument 'esxes' to be a list")
        pulumi.set(__self__, "esxes", esxes)
        if hypervs and not isinstance(hypervs, list):
            raise TypeError("Expected argument 'hypervs' to be a list")
        pulumi.set(__self__, "hypervs", hypervs)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if kvms and not isinstance(kvms, list):
            raise TypeError("Expected argument 'kvms' to be a list")
        pulumi.set(__self__, "kvms", kvms)
        if linuxes and not isinstance(linuxes, list):
            raise TypeError("Expected argument 'linuxes' to be a list")
        pulumi.set(__self__, "linuxes", linuxes)
        if xens and not isinstance(xens, list):
            raise TypeError("Expected argument 'xens' to be a list")
        pulumi.set(__self__, "xens", xens)

    @property
    @pulumi.getter
    def esxes(self) -> Sequence['outputs.GetFoundationHypervisorIsosEsxResult']:
        return pulumi.get(self, "esxes")

    @property
    @pulumi.getter
    def hypervs(self) -> Sequence['outputs.GetFoundationHypervisorIsosHypervResult']:
        return pulumi.get(self, "hypervs")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def kvms(self) -> Sequence['outputs.GetFoundationHypervisorIsosKvmResult']:
        return pulumi.get(self, "kvms")

    @property
    @pulumi.getter
    def linuxes(self) -> Sequence['outputs.GetFoundationHypervisorIsosLinuxResult']:
        return pulumi.get(self, "linuxes")

    @property
    @pulumi.getter
    def xens(self) -> Sequence['outputs.GetFoundationHypervisorIsosXenResult']:
        return pulumi.get(self, "xens")


class AwaitableGetFoundationHypervisorIsosResult(GetFoundationHypervisorIsosResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFoundationHypervisorIsosResult(
            esxes=self.esxes,
            hypervs=self.hypervs,
            id=self.id,
            kvms=self.kvms,
            linuxes=self.linuxes,
            xens=self.xens)


def get_foundation_hypervisor_isos(opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFoundationHypervisorIsosResult:
    """
    Describes a list of hypervisor isos image file details present in foundation vm

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    hypervisor_isos = nutanix.get_foundation_hypervisor_isos()
    ```
    ## Note

    * This data source only lists .iso files details.

    See detailed information in [Nutanix Foundation Hypervisor Isos](https://www.nutanix.dev/api_references/foundation/#/b3A6MjIyMjM0MDE-list-hypervisor-images-available-in-foundation).
    """
    __args__ = dict()
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('nutanix:index/getFoundationHypervisorIsos:getFoundationHypervisorIsos', __args__, opts=opts, typ=GetFoundationHypervisorIsosResult).value

    return AwaitableGetFoundationHypervisorIsosResult(
        esxes=__ret__.esxes,
        hypervs=__ret__.hypervs,
        id=__ret__.id,
        kvms=__ret__.kvms,
        linuxes=__ret__.linuxes,
        xens=__ret__.xens)
