# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'GetFoundationNodeNetworkDetailsResult',
    'AwaitableGetFoundationNodeNetworkDetailsResult',
    'get_foundation_node_network_details',
    'get_foundation_node_network_details_output',
]

@pulumi.output_type
class GetFoundationNodeNetworkDetailsResult:
    """
    A collection of values returned by getFoundationNodeNetworkDetails.
    """
    def __init__(__self__, id=None, ipv6_addresses=None, nodes=None, timeout=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if ipv6_addresses and not isinstance(ipv6_addresses, list):
            raise TypeError("Expected argument 'ipv6_addresses' to be a list")
        pulumi.set(__self__, "ipv6_addresses", ipv6_addresses)
        if nodes and not isinstance(nodes, list):
            raise TypeError("Expected argument 'nodes' to be a list")
        pulumi.set(__self__, "nodes", nodes)
        if timeout and not isinstance(timeout, str):
            raise TypeError("Expected argument 'timeout' to be a str")
        pulumi.set(__self__, "timeout", timeout)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="ipv6Addresses")
    def ipv6_addresses(self) -> Sequence[str]:
        return pulumi.get(self, "ipv6_addresses")

    @property
    @pulumi.getter
    def nodes(self) -> Sequence['outputs.GetFoundationNodeNetworkDetailsNodeResult']:
        return pulumi.get(self, "nodes")

    @property
    @pulumi.getter
    def timeout(self) -> Optional[str]:
        return pulumi.get(self, "timeout")


class AwaitableGetFoundationNodeNetworkDetailsResult(GetFoundationNodeNetworkDetailsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFoundationNodeNetworkDetailsResult(
            id=self.id,
            ipv6_addresses=self.ipv6_addresses,
            nodes=self.nodes,
            timeout=self.timeout)


def get_foundation_node_network_details(ipv6_addresses: Optional[Sequence[str]] = None,
                                        timeout: Optional[str] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFoundationNodeNetworkDetailsResult:
    """
    Gets hypervisor, CVM & IPMI info of the discovered nodes using their ipv6 address.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    network_details = nutanix.get_foundation_node_network_details(ipv6_addresses=[
            "<ipv6-address-1>",
            "<ipv6-address-2>",
        ],
        timeout="30")
    ```
    """
    __args__ = dict()
    __args__['ipv6Addresses'] = ipv6_addresses
    __args__['timeout'] = timeout
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('nutanix:index/getFoundationNodeNetworkDetails:getFoundationNodeNetworkDetails', __args__, opts=opts, typ=GetFoundationNodeNetworkDetailsResult).value

    return AwaitableGetFoundationNodeNetworkDetailsResult(
        id=__ret__.id,
        ipv6_addresses=__ret__.ipv6_addresses,
        nodes=__ret__.nodes,
        timeout=__ret__.timeout)


@_utilities.lift_output_func(get_foundation_node_network_details)
def get_foundation_node_network_details_output(ipv6_addresses: Optional[pulumi.Input[Sequence[str]]] = None,
                                               timeout: Optional[pulumi.Input[Optional[str]]] = None,
                                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetFoundationNodeNetworkDetailsResult]:
    """
    Gets hypervisor, CVM & IPMI info of the discovered nodes using their ipv6 address.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    network_details = nutanix.get_foundation_node_network_details(ipv6_addresses=[
            "<ipv6-address-1>",
            "<ipv6-address-2>",
        ],
        timeout="30")
    ```
    """
    ...
