# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'GetHostsResult',
    'AwaitableGetHostsResult',
    'get_hosts',
]

@pulumi.output_type
class GetHostsResult:
    """
    A collection of values returned by getHosts.
    """
    def __init__(__self__, api_version=None, entities=None, id=None):
        if api_version and not isinstance(api_version, str):
            raise TypeError("Expected argument 'api_version' to be a str")
        pulumi.set(__self__, "api_version", api_version)
        if entities and not isinstance(entities, list):
            raise TypeError("Expected argument 'entities' to be a list")
        pulumi.set(__self__, "entities", entities)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter(name="apiVersion")
    def api_version(self) -> str:
        """
        The API version.
        * `gpu_driver_version`: - Host GPU driver version.
        * `failover_cluster`: - Hyper-V failover cluster.
        * `ipmi`: - Host IPMI info.
        * `cpu_model`: - Host CPU model.
        * `host_nics_id_list`: - Host NICs.
        * `num_cpu_sockets`: - Number of CPU sockets.
        * `windows_domain`: - The name of the node to be renamed to during domain-join. If not given,a new name will be automatically assigned.
        * `gpu_list`: - List of GPUs on the host.
        * `serial_number`: - Node serial number.
        * `cpu_capacity_hz`: - Host CPU capacity.
        * `memory_capacity_mib`: - Host memory capacity in MiB.
        * `host_disks_reference_list`: - The reference to a disk.
        * `monitoring_state`: - Host monitoring status.
        * `hypervisor`: - Host Hypervisor information.
        * `host_type`: - Host type.
        * `num_cpu_cores`: - Number of CPU cores on Host.
        * `rackable_unit_reference`: - The reference to a rackable_unit.
        * `controller_vm`: - Host controller vm information.
        * `block`: - Host block config info.
        """
        return pulumi.get(self, "api_version")

    @property
    @pulumi.getter
    def entities(self) -> Sequence['outputs.GetHostsEntityResult']:
        return pulumi.get(self, "entities")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")


class AwaitableGetHostsResult(GetHostsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetHostsResult(
            api_version=self.api_version,
            entities=self.entities,
            id=self.id)


def get_hosts(opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetHostsResult:
    """
    Describes a list of hosts
    """
    __args__ = dict()
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('nutanix:index/getHosts:getHosts', __args__, opts=opts, typ=GetHostsResult).value

    return AwaitableGetHostsResult(
        api_version=__ret__.api_version,
        entities=__ret__.entities,
        id=__ret__.id)
