# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetKarbonClusterKubeConfigResult',
    'AwaitableGetKarbonClusterKubeConfigResult',
    'get_karbon_cluster_kube_config',
    'get_karbon_cluster_kube_config_output',
]

@pulumi.output_type
class GetKarbonClusterKubeConfigResult:
    """
    A collection of values returned by getKarbonClusterKubeConfig.
    """
    def __init__(__self__, access_token=None, cluster_ca_certificate=None, cluster_url=None, id=None, karbon_cluster_id=None, karbon_cluster_name=None, name=None):
        if access_token and not isinstance(access_token, str):
            raise TypeError("Expected argument 'access_token' to be a str")
        pulumi.set(__self__, "access_token", access_token)
        if cluster_ca_certificate and not isinstance(cluster_ca_certificate, str):
            raise TypeError("Expected argument 'cluster_ca_certificate' to be a str")
        pulumi.set(__self__, "cluster_ca_certificate", cluster_ca_certificate)
        if cluster_url and not isinstance(cluster_url, str):
            raise TypeError("Expected argument 'cluster_url' to be a str")
        pulumi.set(__self__, "cluster_url", cluster_url)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if karbon_cluster_id and not isinstance(karbon_cluster_id, str):
            raise TypeError("Expected argument 'karbon_cluster_id' to be a str")
        pulumi.set(__self__, "karbon_cluster_id", karbon_cluster_id)
        if karbon_cluster_name and not isinstance(karbon_cluster_name, str):
            raise TypeError("Expected argument 'karbon_cluster_name' to be a str")
        pulumi.set(__self__, "karbon_cluster_name", karbon_cluster_name)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="accessToken")
    def access_token(self) -> str:
        return pulumi.get(self, "access_token")

    @property
    @pulumi.getter(name="clusterCaCertificate")
    def cluster_ca_certificate(self) -> str:
        return pulumi.get(self, "cluster_ca_certificate")

    @property
    @pulumi.getter(name="clusterUrl")
    def cluster_url(self) -> str:
        return pulumi.get(self, "cluster_url")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="karbonClusterId")
    def karbon_cluster_id(self) -> Optional[str]:
        return pulumi.get(self, "karbon_cluster_id")

    @property
    @pulumi.getter(name="karbonClusterName")
    def karbon_cluster_name(self) -> Optional[str]:
        return pulumi.get(self, "karbon_cluster_name")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")


class AwaitableGetKarbonClusterKubeConfigResult(GetKarbonClusterKubeConfigResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetKarbonClusterKubeConfigResult(
            access_token=self.access_token,
            cluster_ca_certificate=self.cluster_ca_certificate,
            cluster_url=self.cluster_url,
            id=self.id,
            karbon_cluster_id=self.karbon_cluster_id,
            karbon_cluster_name=self.karbon_cluster_name,
            name=self.name)


def get_karbon_cluster_kube_config(karbon_cluster_id: Optional[str] = None,
                                   karbon_cluster_name: Optional[str] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetKarbonClusterKubeConfigResult:
    """
    Describes the SSH config from a Karbon Cluster

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    configbyid = nutanix.get_karbon_cluster_kube_config(karbon_cluster_id="<YOUR-CLUSTER-ID>")
    configbyname = nutanix.get_karbon_cluster_kube_config(karbon_cluster_name="<YOUR-CLUSTER-NAME>")
    ```
    """
    __args__ = dict()
    __args__['karbonClusterId'] = karbon_cluster_id
    __args__['karbonClusterName'] = karbon_cluster_name
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('nutanix:index/getKarbonClusterKubeConfig:getKarbonClusterKubeConfig', __args__, opts=opts, typ=GetKarbonClusterKubeConfigResult).value

    return AwaitableGetKarbonClusterKubeConfigResult(
        access_token=__ret__.access_token,
        cluster_ca_certificate=__ret__.cluster_ca_certificate,
        cluster_url=__ret__.cluster_url,
        id=__ret__.id,
        karbon_cluster_id=__ret__.karbon_cluster_id,
        karbon_cluster_name=__ret__.karbon_cluster_name,
        name=__ret__.name)


@_utilities.lift_output_func(get_karbon_cluster_kube_config)
def get_karbon_cluster_kube_config_output(karbon_cluster_id: Optional[pulumi.Input[Optional[str]]] = None,
                                          karbon_cluster_name: Optional[pulumi.Input[Optional[str]]] = None,
                                          opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetKarbonClusterKubeConfigResult]:
    """
    Describes the SSH config from a Karbon Cluster

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    configbyid = nutanix.get_karbon_cluster_kube_config(karbon_cluster_id="<YOUR-CLUSTER-ID>")
    configbyname = nutanix.get_karbon_cluster_kube_config(karbon_cluster_name="<YOUR-CLUSTER-NAME>")
    ```
    """
    ...
