# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetProtectionRuleResult',
    'AwaitableGetProtectionRuleResult',
    'get_protection_rule',
    'get_protection_rule_output',
]

@pulumi.output_type
class GetProtectionRuleResult:
    """
    A collection of values returned by getProtectionRule.
    """
    def __init__(__self__, api_version=None, availability_zone_connectivity_lists=None, categories=None, category_filters=None, description=None, id=None, metadata=None, name=None, ordered_availability_zone_lists=None, owner_references=None, project_references=None, protection_rule_id=None, protection_rule_name=None, start_time=None, state=None):
        if api_version and not isinstance(api_version, str):
            raise TypeError("Expected argument 'api_version' to be a str")
        pulumi.set(__self__, "api_version", api_version)
        if availability_zone_connectivity_lists and not isinstance(availability_zone_connectivity_lists, list):
            raise TypeError("Expected argument 'availability_zone_connectivity_lists' to be a list")
        pulumi.set(__self__, "availability_zone_connectivity_lists", availability_zone_connectivity_lists)
        if categories and not isinstance(categories, list):
            raise TypeError("Expected argument 'categories' to be a list")
        pulumi.set(__self__, "categories", categories)
        if category_filters and not isinstance(category_filters, list):
            raise TypeError("Expected argument 'category_filters' to be a list")
        pulumi.set(__self__, "category_filters", category_filters)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if metadata and not isinstance(metadata, dict):
            raise TypeError("Expected argument 'metadata' to be a dict")
        pulumi.set(__self__, "metadata", metadata)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if ordered_availability_zone_lists and not isinstance(ordered_availability_zone_lists, list):
            raise TypeError("Expected argument 'ordered_availability_zone_lists' to be a list")
        pulumi.set(__self__, "ordered_availability_zone_lists", ordered_availability_zone_lists)
        if owner_references and not isinstance(owner_references, list):
            raise TypeError("Expected argument 'owner_references' to be a list")
        pulumi.set(__self__, "owner_references", owner_references)
        if project_references and not isinstance(project_references, list):
            raise TypeError("Expected argument 'project_references' to be a list")
        pulumi.set(__self__, "project_references", project_references)
        if protection_rule_id and not isinstance(protection_rule_id, str):
            raise TypeError("Expected argument 'protection_rule_id' to be a str")
        pulumi.set(__self__, "protection_rule_id", protection_rule_id)
        if protection_rule_name and not isinstance(protection_rule_name, str):
            raise TypeError("Expected argument 'protection_rule_name' to be a str")
        pulumi.set(__self__, "protection_rule_name", protection_rule_name)
        if start_time and not isinstance(start_time, str):
            raise TypeError("Expected argument 'start_time' to be a str")
        pulumi.set(__self__, "start_time", start_time)
        if state and not isinstance(state, str):
            raise TypeError("Expected argument 'state' to be a str")
        pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter(name="apiVersion")
    def api_version(self) -> str:
        return pulumi.get(self, "api_version")

    @property
    @pulumi.getter(name="availabilityZoneConnectivityLists")
    def availability_zone_connectivity_lists(self) -> Sequence['outputs.GetProtectionRuleAvailabilityZoneConnectivityListResult']:
        """
        (Required) This encodes the datapipes between various availability zones and\nthe backup policy of the pipes.
        * `availability_zone_connectivity_list.destination_availability_zone_index` - (Optional/Computed) Index of the availability zone.
        * `availability_zone_connectivity_list.source_availability_zone_index` - (Optional/Computed) Index of the availability zone.
        * `availability_zone_connectivity_list.snapshot_schedule_list` - (Optional/Computed) Snapshot schedules for the pair of the availability zones.
        * `availability_zone_connectivity_list.snapshot_schedule_list.#.recovery_point_objective_secs` - (Required) "A recovery point objective (RPO) is the maximum acceptable amount of data loss.
        * `availability_zone_connectivity_list.snapshot_schedule_list.#.local_snapshot_retention_policy` - (Optional/Computed) This describes the snapshot retention policy for this availability zone.
        * `availability_zone_connectivity_list.snapshot_schedule_list.#.local_snapshot_retention_policy.0.num_snapshots` - (Optional/Computed) Number of snapshots need to be retained.
        * `availability_zone_connectivity_list.snapshot_schedule_list.#.local_snapshot_retention_policy.0.rollup_retention_policy_multiple` - (Optional/Computed) Multiplier to 'snapshot_interval_type'.
        * `availability_zone_connectivity_list.snapshot_schedule_list.#.local_snapshot_retention_policy.0.rollup_retention_policy_snapshot_interval_type` - (Optional/Computed)
        * `availability_zone_connectivity_list.snapshot_schedule_list.#.auto_suspend_timeout_secs` - (Optional/Computed) Auto suspend timeout in case of connection failure between the sites.
        * `availability_zone_connectivity_list.snapshot_schedule_list.#.snapshot_type` - (Optional/Computed) Crash consistent or Application Consistent snapshot.
        * `availability_zone_connectivity_list.snapshot_schedule_list.#.remote_snapshot_retention_policy` - (Optional/Computed) This describes the snapshot retention policy for this availability zone.
        """
        return pulumi.get(self, "availability_zone_connectivity_lists")

    @property
    @pulumi.getter
    def categories(self) -> Sequence['outputs.GetProtectionRuleCategoryResult']:
        return pulumi.get(self, "categories")

    @property
    @pulumi.getter(name="categoryFilters")
    def category_filters(self) -> Sequence['outputs.GetProtectionRuleCategoryFilterResult']:
        """
        (Optional/Computed)
        * `category_filter.0.type` - (Optional/Computed) The type of the filter being used.
        * `category_filter.0.kind_list` - (Optional/Computed) List of kinds associated with this filter.
        * `category_filter.0.params` - (Optional/Computed) A list of category key and list of values.
        """
        return pulumi.get(self, "category_filters")

    @property
    @pulumi.getter
    def description(self) -> str:
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def metadata(self) -> Mapping[str, str]:
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        (Optional) the name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="orderedAvailabilityZoneLists")
    def ordered_availability_zone_lists(self) -> Sequence['outputs.GetProtectionRuleOrderedAvailabilityZoneListResult']:
        """
        (Required) A list of availability zones, each of which, receives a replica\nof the data for the entities protected by this protection rule.
        * `ordered_availability_zone_list.#.cluster_uuid` - (Optional/Computed) UUID of specific cluster to which we will be replicating.
        * `ordered_availability_zone_list.#.availability_zone_url` - (Optional/Computed) The FQDN or IP address of the availability zone.
        """
        return pulumi.get(self, "ordered_availability_zone_lists")

    @property
    @pulumi.getter(name="ownerReferences")
    def owner_references(self) -> Sequence['outputs.GetProtectionRuleOwnerReferenceResult']:
        return pulumi.get(self, "owner_references")

    @property
    @pulumi.getter(name="projectReferences")
    def project_references(self) -> Sequence['outputs.GetProtectionRuleProjectReferenceResult']:
        return pulumi.get(self, "project_references")

    @property
    @pulumi.getter(name="protectionRuleId")
    def protection_rule_id(self) -> Optional[str]:
        return pulumi.get(self, "protection_rule_id")

    @property
    @pulumi.getter(name="protectionRuleName")
    def protection_rule_name(self) -> Optional[str]:
        return pulumi.get(self, "protection_rule_name")

    @property
    @pulumi.getter(name="startTime")
    def start_time(self) -> str:
        return pulumi.get(self, "start_time")

    @property
    @pulumi.getter
    def state(self) -> str:
        return pulumi.get(self, "state")


class AwaitableGetProtectionRuleResult(GetProtectionRuleResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetProtectionRuleResult(
            api_version=self.api_version,
            availability_zone_connectivity_lists=self.availability_zone_connectivity_lists,
            categories=self.categories,
            category_filters=self.category_filters,
            description=self.description,
            id=self.id,
            metadata=self.metadata,
            name=self.name,
            ordered_availability_zone_lists=self.ordered_availability_zone_lists,
            owner_references=self.owner_references,
            project_references=self.project_references,
            protection_rule_id=self.protection_rule_id,
            protection_rule_name=self.protection_rule_name,
            start_time=self.start_time,
            state=self.state)


def get_protection_rule(categories: Optional[Sequence[pulumi.InputType['GetProtectionRuleCategoryArgs']]] = None,
                        protection_rule_id: Optional[str] = None,
                        protection_rule_name: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetProtectionRuleResult:
    """
    Describe a Nutanix Protection Rule and its values (if it has them).

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    protection_rule_test = nutanix.ProtectionRule("protectionRuleTest",
        description="test",
        ordered_availability_zone_lists=[nutanix.ProtectionRuleOrderedAvailabilityZoneListArgs(
            availability_zone_url="ab788130-0820-4d07-a1b5-b0ba4d3a42asd",
        )],
        availability_zone_connectivity_lists=[nutanix.ProtectionRuleAvailabilityZoneConnectivityListArgs(
            snapshot_schedule_lists=[nutanix.ProtectionRuleAvailabilityZoneConnectivityListSnapshotScheduleListArgs(
                recovery_point_objective_secs=3600,
                snapshot_type="CRASH_CONSISTENT",
                local_snapshot_retention_policy=nutanix.ProtectionRuleAvailabilityZoneConnectivityListSnapshotScheduleListLocalSnapshotRetentionPolicyArgs(
                    num_snapshots=1,
                ),
            )],
        )],
        category_filter=nutanix.ProtectionRuleCategoryFilterArgs(
            params=[nutanix.ProtectionRuleCategoryFilterParamArgs(
                name="Environment",
                values=["Dev"],
            )],
        ))
    test = nutanix.get_protection_rule_output(protection_rule_id=protection_rule_test.id)
    ```
    """
    __args__ = dict()
    __args__['categories'] = categories
    __args__['protectionRuleId'] = protection_rule_id
    __args__['protectionRuleName'] = protection_rule_name
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('nutanix:index/getProtectionRule:getProtectionRule', __args__, opts=opts, typ=GetProtectionRuleResult).value

    return AwaitableGetProtectionRuleResult(
        api_version=__ret__.api_version,
        availability_zone_connectivity_lists=__ret__.availability_zone_connectivity_lists,
        categories=__ret__.categories,
        category_filters=__ret__.category_filters,
        description=__ret__.description,
        id=__ret__.id,
        metadata=__ret__.metadata,
        name=__ret__.name,
        ordered_availability_zone_lists=__ret__.ordered_availability_zone_lists,
        owner_references=__ret__.owner_references,
        project_references=__ret__.project_references,
        protection_rule_id=__ret__.protection_rule_id,
        protection_rule_name=__ret__.protection_rule_name,
        start_time=__ret__.start_time,
        state=__ret__.state)


@_utilities.lift_output_func(get_protection_rule)
def get_protection_rule_output(categories: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetProtectionRuleCategoryArgs']]]]] = None,
                               protection_rule_id: Optional[pulumi.Input[Optional[str]]] = None,
                               protection_rule_name: Optional[pulumi.Input[Optional[str]]] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetProtectionRuleResult]:
    """
    Describe a Nutanix Protection Rule and its values (if it has them).

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    protection_rule_test = nutanix.ProtectionRule("protectionRuleTest",
        description="test",
        ordered_availability_zone_lists=[nutanix.ProtectionRuleOrderedAvailabilityZoneListArgs(
            availability_zone_url="ab788130-0820-4d07-a1b5-b0ba4d3a42asd",
        )],
        availability_zone_connectivity_lists=[nutanix.ProtectionRuleAvailabilityZoneConnectivityListArgs(
            snapshot_schedule_lists=[nutanix.ProtectionRuleAvailabilityZoneConnectivityListSnapshotScheduleListArgs(
                recovery_point_objective_secs=3600,
                snapshot_type="CRASH_CONSISTENT",
                local_snapshot_retention_policy=nutanix.ProtectionRuleAvailabilityZoneConnectivityListSnapshotScheduleListLocalSnapshotRetentionPolicyArgs(
                    num_snapshots=1,
                ),
            )],
        )],
        category_filter=nutanix.ProtectionRuleCategoryFilterArgs(
            params=[nutanix.ProtectionRuleCategoryFilterParamArgs(
                name="Environment",
                values=["Dev"],
            )],
        ))
    test = nutanix.get_protection_rule_output(protection_rule_id=protection_rule_test.id)
    ```
    """
    ...
