# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ProjectArgs', 'Project']

@pulumi.input_type
class ProjectArgs:
    def __init__(__self__, *,
                 default_subnet_reference: pulumi.Input['ProjectDefaultSubnetReferenceArgs'],
                 description: pulumi.Input[str],
                 account_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectAccountReferenceListArgs']]]] = None,
                 api_version: Optional[pulumi.Input[str]] = None,
                 categories: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectCategoryArgs']]]] = None,
                 environment_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectEnvironmentReferenceListArgs']]]] = None,
                 external_network_lists: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectExternalNetworkListArgs']]]] = None,
                 external_user_group_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectExternalUserGroupReferenceListArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 owner_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 project_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 resource_domain: Optional[pulumi.Input['ProjectResourceDomainArgs']] = None,
                 subnet_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectSubnetReferenceListArgs']]]] = None,
                 user_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectUserReferenceListArgs']]]] = None):
        """
        The set of arguments for constructing a Project resource.
        :param pulumi.Input['ProjectDefaultSubnetReferenceArgs'] default_subnet_reference: Reference to a subnet.
               * `default_subnet_reference.kind` - (Optional) The kind name. Default value is `subnet`
               * `default_subnet_reference.uuid` - (Required) The UUID of a subnet.
               * `default_subnet_reference.name` - (Optional/Computed) The name of a subnet.
        :param pulumi.Input[str] description: A description for project.
        :param pulumi.Input[Sequence[pulumi.Input['ProjectAccountReferenceListArgs']]] account_reference_lists: List of accounts associated with the project.
               * `account_reference_list.#.kind` - (Optional) The kind name. Default value is `account`
               * `account_reference_list.#.uuid` - (Required) The UUID of an account.
               * `account_reference_list.#.name` - (Optional/Computed) The name of an account.
        :param pulumi.Input[Sequence[pulumi.Input['ProjectEnvironmentReferenceListArgs']]] environment_reference_lists: List of environments associated with the project.
               * `environment_reference_list.#.kind` - (Optional) The kind name. Default value is `environment`
               * `environment_reference_list.#.uuid` - (Required) The UUID of an environment.
               * `environment_reference_list.#.name` - (Optional/Computed) The name of an environment.
        :param pulumi.Input[Sequence[pulumi.Input['ProjectExternalNetworkListArgs']]] external_network_lists: List of external networks associated with the project.
               * `external_network_list.#.uuid` - (Required) The UUID of a network.
               * `external_network_list.#.name` - (Optional/Computed) The name of a network.
        :param pulumi.Input[Sequence[pulumi.Input['ProjectExternalUserGroupReferenceListArgs']]] external_user_group_reference_lists: List of directory service user groups. These groups are not managed by Nutanix.
               * `external_user_group_reference_list.#.kind` - (Optional) The kind name. Default value is `user_group`
               * `external_user_group_reference_list.#.uuid` - (Required) The UUID of a user_group
               * `external_user_group_reference_list.#.name` - (Optional/Computed) The name of a user_group
        :param pulumi.Input[str] name: The name for the project.
        :param pulumi.Input['ProjectResourceDomainArgs'] resource_domain: The status for a resource domain (limits and values)
               * `resource_domain.resources` - (Required) Array of the utilization/limit for resource types
               * `resource_domain.resources.#.limit` - (Required) The resource consumption limit (unspecified is unlimited)
               * `resource_domain.resources.#.resource_type` - (Required) The type of resource (for example storage, CPUs)
        :param pulumi.Input[Sequence[pulumi.Input['ProjectSubnetReferenceListArgs']]] subnet_reference_lists: List of subnets for the project.
               * `subnet_reference_list.#.kind` - (Optional) The kind name. Default value is `subnet`
               * `subnet_reference_list.#.uuid` - (Required) The UUID of a subnet
               * `subnet_reference_list.#.name` - (Optional/Computed) The name of a subnet.
        :param pulumi.Input[Sequence[pulumi.Input['ProjectUserReferenceListArgs']]] user_reference_lists: List of users in the project.
               * `user_reference_list.#.kind` - (Optional) The kind name. Default value is `user`
               * `user_reference_list.#.uuid` - (Required) The UUID of a user
               * `user_reference_list.#.name` - (Optional/Computed) The name of a user.
        """
        pulumi.set(__self__, "default_subnet_reference", default_subnet_reference)
        pulumi.set(__self__, "description", description)
        if account_reference_lists is not None:
            pulumi.set(__self__, "account_reference_lists", account_reference_lists)
        if api_version is not None:
            pulumi.set(__self__, "api_version", api_version)
        if categories is not None:
            pulumi.set(__self__, "categories", categories)
        if environment_reference_lists is not None:
            pulumi.set(__self__, "environment_reference_lists", environment_reference_lists)
        if external_network_lists is not None:
            pulumi.set(__self__, "external_network_lists", external_network_lists)
        if external_user_group_reference_lists is not None:
            pulumi.set(__self__, "external_user_group_reference_lists", external_user_group_reference_lists)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if owner_reference is not None:
            pulumi.set(__self__, "owner_reference", owner_reference)
        if project_reference is not None:
            pulumi.set(__self__, "project_reference", project_reference)
        if resource_domain is not None:
            pulumi.set(__self__, "resource_domain", resource_domain)
        if subnet_reference_lists is not None:
            pulumi.set(__self__, "subnet_reference_lists", subnet_reference_lists)
        if user_reference_lists is not None:
            pulumi.set(__self__, "user_reference_lists", user_reference_lists)

    @property
    @pulumi.getter(name="defaultSubnetReference")
    def default_subnet_reference(self) -> pulumi.Input['ProjectDefaultSubnetReferenceArgs']:
        """
        Reference to a subnet.
        * `default_subnet_reference.kind` - (Optional) The kind name. Default value is `subnet`
        * `default_subnet_reference.uuid` - (Required) The UUID of a subnet.
        * `default_subnet_reference.name` - (Optional/Computed) The name of a subnet.
        """
        return pulumi.get(self, "default_subnet_reference")

    @default_subnet_reference.setter
    def default_subnet_reference(self, value: pulumi.Input['ProjectDefaultSubnetReferenceArgs']):
        pulumi.set(self, "default_subnet_reference", value)

    @property
    @pulumi.getter
    def description(self) -> pulumi.Input[str]:
        """
        A description for project.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: pulumi.Input[str]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="accountReferenceLists")
    def account_reference_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProjectAccountReferenceListArgs']]]]:
        """
        List of accounts associated with the project.
        * `account_reference_list.#.kind` - (Optional) The kind name. Default value is `account`
        * `account_reference_list.#.uuid` - (Required) The UUID of an account.
        * `account_reference_list.#.name` - (Optional/Computed) The name of an account.
        """
        return pulumi.get(self, "account_reference_lists")

    @account_reference_lists.setter
    def account_reference_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectAccountReferenceListArgs']]]]):
        pulumi.set(self, "account_reference_lists", value)

    @property
    @pulumi.getter(name="apiVersion")
    def api_version(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "api_version")

    @api_version.setter
    def api_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "api_version", value)

    @property
    @pulumi.getter
    def categories(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProjectCategoryArgs']]]]:
        return pulumi.get(self, "categories")

    @categories.setter
    def categories(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectCategoryArgs']]]]):
        pulumi.set(self, "categories", value)

    @property
    @pulumi.getter(name="environmentReferenceLists")
    def environment_reference_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProjectEnvironmentReferenceListArgs']]]]:
        """
        List of environments associated with the project.
        * `environment_reference_list.#.kind` - (Optional) The kind name. Default value is `environment`
        * `environment_reference_list.#.uuid` - (Required) The UUID of an environment.
        * `environment_reference_list.#.name` - (Optional/Computed) The name of an environment.
        """
        return pulumi.get(self, "environment_reference_lists")

    @environment_reference_lists.setter
    def environment_reference_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectEnvironmentReferenceListArgs']]]]):
        pulumi.set(self, "environment_reference_lists", value)

    @property
    @pulumi.getter(name="externalNetworkLists")
    def external_network_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProjectExternalNetworkListArgs']]]]:
        """
        List of external networks associated with the project.
        * `external_network_list.#.uuid` - (Required) The UUID of a network.
        * `external_network_list.#.name` - (Optional/Computed) The name of a network.
        """
        return pulumi.get(self, "external_network_lists")

    @external_network_lists.setter
    def external_network_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectExternalNetworkListArgs']]]]):
        pulumi.set(self, "external_network_lists", value)

    @property
    @pulumi.getter(name="externalUserGroupReferenceLists")
    def external_user_group_reference_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProjectExternalUserGroupReferenceListArgs']]]]:
        """
        List of directory service user groups. These groups are not managed by Nutanix.
        * `external_user_group_reference_list.#.kind` - (Optional) The kind name. Default value is `user_group`
        * `external_user_group_reference_list.#.uuid` - (Required) The UUID of a user_group
        * `external_user_group_reference_list.#.name` - (Optional/Computed) The name of a user_group
        """
        return pulumi.get(self, "external_user_group_reference_lists")

    @external_user_group_reference_lists.setter
    def external_user_group_reference_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectExternalUserGroupReferenceListArgs']]]]):
        pulumi.set(self, "external_user_group_reference_lists", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name for the project.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="ownerReference")
    def owner_reference(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "owner_reference")

    @owner_reference.setter
    def owner_reference(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "owner_reference", value)

    @property
    @pulumi.getter(name="projectReference")
    def project_reference(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "project_reference")

    @project_reference.setter
    def project_reference(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "project_reference", value)

    @property
    @pulumi.getter(name="resourceDomain")
    def resource_domain(self) -> Optional[pulumi.Input['ProjectResourceDomainArgs']]:
        """
        The status for a resource domain (limits and values)
        * `resource_domain.resources` - (Required) Array of the utilization/limit for resource types
        * `resource_domain.resources.#.limit` - (Required) The resource consumption limit (unspecified is unlimited)
        * `resource_domain.resources.#.resource_type` - (Required) The type of resource (for example storage, CPUs)
        """
        return pulumi.get(self, "resource_domain")

    @resource_domain.setter
    def resource_domain(self, value: Optional[pulumi.Input['ProjectResourceDomainArgs']]):
        pulumi.set(self, "resource_domain", value)

    @property
    @pulumi.getter(name="subnetReferenceLists")
    def subnet_reference_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProjectSubnetReferenceListArgs']]]]:
        """
        List of subnets for the project.
        * `subnet_reference_list.#.kind` - (Optional) The kind name. Default value is `subnet`
        * `subnet_reference_list.#.uuid` - (Required) The UUID of a subnet
        * `subnet_reference_list.#.name` - (Optional/Computed) The name of a subnet.
        """
        return pulumi.get(self, "subnet_reference_lists")

    @subnet_reference_lists.setter
    def subnet_reference_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectSubnetReferenceListArgs']]]]):
        pulumi.set(self, "subnet_reference_lists", value)

    @property
    @pulumi.getter(name="userReferenceLists")
    def user_reference_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProjectUserReferenceListArgs']]]]:
        """
        List of users in the project.
        * `user_reference_list.#.kind` - (Optional) The kind name. Default value is `user`
        * `user_reference_list.#.uuid` - (Required) The UUID of a user
        * `user_reference_list.#.name` - (Optional/Computed) The name of a user.
        """
        return pulumi.get(self, "user_reference_lists")

    @user_reference_lists.setter
    def user_reference_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectUserReferenceListArgs']]]]):
        pulumi.set(self, "user_reference_lists", value)


@pulumi.input_type
class _ProjectState:
    def __init__(__self__, *,
                 account_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectAccountReferenceListArgs']]]] = None,
                 api_version: Optional[pulumi.Input[str]] = None,
                 categories: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectCategoryArgs']]]] = None,
                 default_subnet_reference: Optional[pulumi.Input['ProjectDefaultSubnetReferenceArgs']] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 environment_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectEnvironmentReferenceListArgs']]]] = None,
                 external_network_lists: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectExternalNetworkListArgs']]]] = None,
                 external_user_group_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectExternalUserGroupReferenceListArgs']]]] = None,
                 is_default: Optional[pulumi.Input[bool]] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 owner_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 project_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 resource_domain: Optional[pulumi.Input['ProjectResourceDomainArgs']] = None,
                 state: Optional[pulumi.Input[str]] = None,
                 subnet_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectSubnetReferenceListArgs']]]] = None,
                 user_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectUserReferenceListArgs']]]] = None):
        """
        Input properties used for looking up and filtering Project resources.
        :param pulumi.Input[Sequence[pulumi.Input['ProjectAccountReferenceListArgs']]] account_reference_lists: List of accounts associated with the project.
               * `account_reference_list.#.kind` - (Optional) The kind name. Default value is `account`
               * `account_reference_list.#.uuid` - (Required) The UUID of an account.
               * `account_reference_list.#.name` - (Optional/Computed) The name of an account.
        :param pulumi.Input['ProjectDefaultSubnetReferenceArgs'] default_subnet_reference: Reference to a subnet.
               * `default_subnet_reference.kind` - (Optional) The kind name. Default value is `subnet`
               * `default_subnet_reference.uuid` - (Required) The UUID of a subnet.
               * `default_subnet_reference.name` - (Optional/Computed) The name of a subnet.
        :param pulumi.Input[str] description: A description for project.
        :param pulumi.Input[Sequence[pulumi.Input['ProjectEnvironmentReferenceListArgs']]] environment_reference_lists: List of environments associated with the project.
               * `environment_reference_list.#.kind` - (Optional) The kind name. Default value is `environment`
               * `environment_reference_list.#.uuid` - (Required) The UUID of an environment.
               * `environment_reference_list.#.name` - (Optional/Computed) The name of an environment.
        :param pulumi.Input[Sequence[pulumi.Input['ProjectExternalNetworkListArgs']]] external_network_lists: List of external networks associated with the project.
               * `external_network_list.#.uuid` - (Required) The UUID of a network.
               * `external_network_list.#.name` - (Optional/Computed) The name of a network.
        :param pulumi.Input[Sequence[pulumi.Input['ProjectExternalUserGroupReferenceListArgs']]] external_user_group_reference_lists: List of directory service user groups. These groups are not managed by Nutanix.
               * `external_user_group_reference_list.#.kind` - (Optional) The kind name. Default value is `user_group`
               * `external_user_group_reference_list.#.uuid` - (Required) The UUID of a user_group
               * `external_user_group_reference_list.#.name` - (Optional/Computed) The name of a user_group
        :param pulumi.Input[str] name: The name for the project.
        :param pulumi.Input['ProjectResourceDomainArgs'] resource_domain: The status for a resource domain (limits and values)
               * `resource_domain.resources` - (Required) Array of the utilization/limit for resource types
               * `resource_domain.resources.#.limit` - (Required) The resource consumption limit (unspecified is unlimited)
               * `resource_domain.resources.#.resource_type` - (Required) The type of resource (for example storage, CPUs)
        :param pulumi.Input[Sequence[pulumi.Input['ProjectSubnetReferenceListArgs']]] subnet_reference_lists: List of subnets for the project.
               * `subnet_reference_list.#.kind` - (Optional) The kind name. Default value is `subnet`
               * `subnet_reference_list.#.uuid` - (Required) The UUID of a subnet
               * `subnet_reference_list.#.name` - (Optional/Computed) The name of a subnet.
        :param pulumi.Input[Sequence[pulumi.Input['ProjectUserReferenceListArgs']]] user_reference_lists: List of users in the project.
               * `user_reference_list.#.kind` - (Optional) The kind name. Default value is `user`
               * `user_reference_list.#.uuid` - (Required) The UUID of a user
               * `user_reference_list.#.name` - (Optional/Computed) The name of a user.
        """
        if account_reference_lists is not None:
            pulumi.set(__self__, "account_reference_lists", account_reference_lists)
        if api_version is not None:
            pulumi.set(__self__, "api_version", api_version)
        if categories is not None:
            pulumi.set(__self__, "categories", categories)
        if default_subnet_reference is not None:
            pulumi.set(__self__, "default_subnet_reference", default_subnet_reference)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if environment_reference_lists is not None:
            pulumi.set(__self__, "environment_reference_lists", environment_reference_lists)
        if external_network_lists is not None:
            pulumi.set(__self__, "external_network_lists", external_network_lists)
        if external_user_group_reference_lists is not None:
            pulumi.set(__self__, "external_user_group_reference_lists", external_user_group_reference_lists)
        if is_default is not None:
            pulumi.set(__self__, "is_default", is_default)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if owner_reference is not None:
            pulumi.set(__self__, "owner_reference", owner_reference)
        if project_reference is not None:
            pulumi.set(__self__, "project_reference", project_reference)
        if resource_domain is not None:
            pulumi.set(__self__, "resource_domain", resource_domain)
        if state is not None:
            pulumi.set(__self__, "state", state)
        if subnet_reference_lists is not None:
            pulumi.set(__self__, "subnet_reference_lists", subnet_reference_lists)
        if user_reference_lists is not None:
            pulumi.set(__self__, "user_reference_lists", user_reference_lists)

    @property
    @pulumi.getter(name="accountReferenceLists")
    def account_reference_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProjectAccountReferenceListArgs']]]]:
        """
        List of accounts associated with the project.
        * `account_reference_list.#.kind` - (Optional) The kind name. Default value is `account`
        * `account_reference_list.#.uuid` - (Required) The UUID of an account.
        * `account_reference_list.#.name` - (Optional/Computed) The name of an account.
        """
        return pulumi.get(self, "account_reference_lists")

    @account_reference_lists.setter
    def account_reference_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectAccountReferenceListArgs']]]]):
        pulumi.set(self, "account_reference_lists", value)

    @property
    @pulumi.getter(name="apiVersion")
    def api_version(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "api_version")

    @api_version.setter
    def api_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "api_version", value)

    @property
    @pulumi.getter
    def categories(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProjectCategoryArgs']]]]:
        return pulumi.get(self, "categories")

    @categories.setter
    def categories(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectCategoryArgs']]]]):
        pulumi.set(self, "categories", value)

    @property
    @pulumi.getter(name="defaultSubnetReference")
    def default_subnet_reference(self) -> Optional[pulumi.Input['ProjectDefaultSubnetReferenceArgs']]:
        """
        Reference to a subnet.
        * `default_subnet_reference.kind` - (Optional) The kind name. Default value is `subnet`
        * `default_subnet_reference.uuid` - (Required) The UUID of a subnet.
        * `default_subnet_reference.name` - (Optional/Computed) The name of a subnet.
        """
        return pulumi.get(self, "default_subnet_reference")

    @default_subnet_reference.setter
    def default_subnet_reference(self, value: Optional[pulumi.Input['ProjectDefaultSubnetReferenceArgs']]):
        pulumi.set(self, "default_subnet_reference", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        A description for project.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="environmentReferenceLists")
    def environment_reference_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProjectEnvironmentReferenceListArgs']]]]:
        """
        List of environments associated with the project.
        * `environment_reference_list.#.kind` - (Optional) The kind name. Default value is `environment`
        * `environment_reference_list.#.uuid` - (Required) The UUID of an environment.
        * `environment_reference_list.#.name` - (Optional/Computed) The name of an environment.
        """
        return pulumi.get(self, "environment_reference_lists")

    @environment_reference_lists.setter
    def environment_reference_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectEnvironmentReferenceListArgs']]]]):
        pulumi.set(self, "environment_reference_lists", value)

    @property
    @pulumi.getter(name="externalNetworkLists")
    def external_network_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProjectExternalNetworkListArgs']]]]:
        """
        List of external networks associated with the project.
        * `external_network_list.#.uuid` - (Required) The UUID of a network.
        * `external_network_list.#.name` - (Optional/Computed) The name of a network.
        """
        return pulumi.get(self, "external_network_lists")

    @external_network_lists.setter
    def external_network_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectExternalNetworkListArgs']]]]):
        pulumi.set(self, "external_network_lists", value)

    @property
    @pulumi.getter(name="externalUserGroupReferenceLists")
    def external_user_group_reference_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProjectExternalUserGroupReferenceListArgs']]]]:
        """
        List of directory service user groups. These groups are not managed by Nutanix.
        * `external_user_group_reference_list.#.kind` - (Optional) The kind name. Default value is `user_group`
        * `external_user_group_reference_list.#.uuid` - (Required) The UUID of a user_group
        * `external_user_group_reference_list.#.name` - (Optional/Computed) The name of a user_group
        """
        return pulumi.get(self, "external_user_group_reference_lists")

    @external_user_group_reference_lists.setter
    def external_user_group_reference_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectExternalUserGroupReferenceListArgs']]]]):
        pulumi.set(self, "external_user_group_reference_lists", value)

    @property
    @pulumi.getter(name="isDefault")
    def is_default(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "is_default")

    @is_default.setter
    def is_default(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_default", value)

    @property
    @pulumi.getter
    def metadata(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "metadata")

    @metadata.setter
    def metadata(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "metadata", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name for the project.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="ownerReference")
    def owner_reference(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "owner_reference")

    @owner_reference.setter
    def owner_reference(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "owner_reference", value)

    @property
    @pulumi.getter(name="projectReference")
    def project_reference(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "project_reference")

    @project_reference.setter
    def project_reference(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "project_reference", value)

    @property
    @pulumi.getter(name="resourceDomain")
    def resource_domain(self) -> Optional[pulumi.Input['ProjectResourceDomainArgs']]:
        """
        The status for a resource domain (limits and values)
        * `resource_domain.resources` - (Required) Array of the utilization/limit for resource types
        * `resource_domain.resources.#.limit` - (Required) The resource consumption limit (unspecified is unlimited)
        * `resource_domain.resources.#.resource_type` - (Required) The type of resource (for example storage, CPUs)
        """
        return pulumi.get(self, "resource_domain")

    @resource_domain.setter
    def resource_domain(self, value: Optional[pulumi.Input['ProjectResourceDomainArgs']]):
        pulumi.set(self, "resource_domain", value)

    @property
    @pulumi.getter
    def state(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "state")

    @state.setter
    def state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "state", value)

    @property
    @pulumi.getter(name="subnetReferenceLists")
    def subnet_reference_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProjectSubnetReferenceListArgs']]]]:
        """
        List of subnets for the project.
        * `subnet_reference_list.#.kind` - (Optional) The kind name. Default value is `subnet`
        * `subnet_reference_list.#.uuid` - (Required) The UUID of a subnet
        * `subnet_reference_list.#.name` - (Optional/Computed) The name of a subnet.
        """
        return pulumi.get(self, "subnet_reference_lists")

    @subnet_reference_lists.setter
    def subnet_reference_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectSubnetReferenceListArgs']]]]):
        pulumi.set(self, "subnet_reference_lists", value)

    @property
    @pulumi.getter(name="userReferenceLists")
    def user_reference_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProjectUserReferenceListArgs']]]]:
        """
        List of users in the project.
        * `user_reference_list.#.kind` - (Optional) The kind name. Default value is `user`
        * `user_reference_list.#.uuid` - (Required) The UUID of a user
        * `user_reference_list.#.name` - (Optional/Computed) The name of a user.
        """
        return pulumi.get(self, "user_reference_lists")

    @user_reference_lists.setter
    def user_reference_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProjectUserReferenceListArgs']]]]):
        pulumi.set(self, "user_reference_lists", value)


class Project(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectAccountReferenceListArgs']]]]] = None,
                 api_version: Optional[pulumi.Input[str]] = None,
                 categories: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectCategoryArgs']]]]] = None,
                 default_subnet_reference: Optional[pulumi.Input[pulumi.InputType['ProjectDefaultSubnetReferenceArgs']]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 environment_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectEnvironmentReferenceListArgs']]]]] = None,
                 external_network_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectExternalNetworkListArgs']]]]] = None,
                 external_user_group_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectExternalUserGroupReferenceListArgs']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 owner_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 project_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 resource_domain: Optional[pulumi.Input[pulumi.InputType['ProjectResourceDomainArgs']]] = None,
                 subnet_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectSubnetReferenceListArgs']]]]] = None,
                 user_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectUserReferenceListArgs']]]]] = None,
                 __props__=None):
        """
        Provides a Nutanix Project resource to Create a Project.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_nutanix as nutanix

        subnet = nutanix.Subnet("subnet",
            cluster_uuid="<YOUR_CLUSTER_ID>",
            description="Description of my unit test VLAN",
            vlan_id=31,
            subnet_type="VLAN",
            subnet_ip="10.250.140.0",
            default_gateway_ip="10.250.140.1",
            prefix_length=24,
            dhcp_options={
                "boot_file_name": "bootfile",
                "domain_name": "nutanix",
                "tftp_server_name": "10.250.140.200",
            },
            dhcp_domain_name_server_lists=[
                "8.8.8.8",
                "4.2.2.2",
            ],
            dhcp_domain_search_lists=[
                "terraform.nutanix.com",
                "terraform.unit.test.com",
            ])
        project_test = nutanix.Project("projectTest",
            description="This is my project",
            categories=[nutanix.ProjectCategoryArgs(
                name="Environment",
                value="Staging",
            )],
            resource_domain=nutanix.ProjectResourceDomainArgs(
                resources=[nutanix.ProjectResourceDomainResourceArgs(
                    limit=4,
                    resource_type="STORAGE",
                )],
            ),
            default_subnet_reference=nutanix.ProjectDefaultSubnetReferenceArgs(
                uuid=subnet.metadata["uuid"],
            ),
            api_version="3.1")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectAccountReferenceListArgs']]]] account_reference_lists: List of accounts associated with the project.
               * `account_reference_list.#.kind` - (Optional) The kind name. Default value is `account`
               * `account_reference_list.#.uuid` - (Required) The UUID of an account.
               * `account_reference_list.#.name` - (Optional/Computed) The name of an account.
        :param pulumi.Input[pulumi.InputType['ProjectDefaultSubnetReferenceArgs']] default_subnet_reference: Reference to a subnet.
               * `default_subnet_reference.kind` - (Optional) The kind name. Default value is `subnet`
               * `default_subnet_reference.uuid` - (Required) The UUID of a subnet.
               * `default_subnet_reference.name` - (Optional/Computed) The name of a subnet.
        :param pulumi.Input[str] description: A description for project.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectEnvironmentReferenceListArgs']]]] environment_reference_lists: List of environments associated with the project.
               * `environment_reference_list.#.kind` - (Optional) The kind name. Default value is `environment`
               * `environment_reference_list.#.uuid` - (Required) The UUID of an environment.
               * `environment_reference_list.#.name` - (Optional/Computed) The name of an environment.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectExternalNetworkListArgs']]]] external_network_lists: List of external networks associated with the project.
               * `external_network_list.#.uuid` - (Required) The UUID of a network.
               * `external_network_list.#.name` - (Optional/Computed) The name of a network.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectExternalUserGroupReferenceListArgs']]]] external_user_group_reference_lists: List of directory service user groups. These groups are not managed by Nutanix.
               * `external_user_group_reference_list.#.kind` - (Optional) The kind name. Default value is `user_group`
               * `external_user_group_reference_list.#.uuid` - (Required) The UUID of a user_group
               * `external_user_group_reference_list.#.name` - (Optional/Computed) The name of a user_group
        :param pulumi.Input[str] name: The name for the project.
        :param pulumi.Input[pulumi.InputType['ProjectResourceDomainArgs']] resource_domain: The status for a resource domain (limits and values)
               * `resource_domain.resources` - (Required) Array of the utilization/limit for resource types
               * `resource_domain.resources.#.limit` - (Required) The resource consumption limit (unspecified is unlimited)
               * `resource_domain.resources.#.resource_type` - (Required) The type of resource (for example storage, CPUs)
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectSubnetReferenceListArgs']]]] subnet_reference_lists: List of subnets for the project.
               * `subnet_reference_list.#.kind` - (Optional) The kind name. Default value is `subnet`
               * `subnet_reference_list.#.uuid` - (Required) The UUID of a subnet
               * `subnet_reference_list.#.name` - (Optional/Computed) The name of a subnet.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectUserReferenceListArgs']]]] user_reference_lists: List of users in the project.
               * `user_reference_list.#.kind` - (Optional) The kind name. Default value is `user`
               * `user_reference_list.#.uuid` - (Required) The UUID of a user
               * `user_reference_list.#.name` - (Optional/Computed) The name of a user.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ProjectArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a Nutanix Project resource to Create a Project.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_nutanix as nutanix

        subnet = nutanix.Subnet("subnet",
            cluster_uuid="<YOUR_CLUSTER_ID>",
            description="Description of my unit test VLAN",
            vlan_id=31,
            subnet_type="VLAN",
            subnet_ip="10.250.140.0",
            default_gateway_ip="10.250.140.1",
            prefix_length=24,
            dhcp_options={
                "boot_file_name": "bootfile",
                "domain_name": "nutanix",
                "tftp_server_name": "10.250.140.200",
            },
            dhcp_domain_name_server_lists=[
                "8.8.8.8",
                "4.2.2.2",
            ],
            dhcp_domain_search_lists=[
                "terraform.nutanix.com",
                "terraform.unit.test.com",
            ])
        project_test = nutanix.Project("projectTest",
            description="This is my project",
            categories=[nutanix.ProjectCategoryArgs(
                name="Environment",
                value="Staging",
            )],
            resource_domain=nutanix.ProjectResourceDomainArgs(
                resources=[nutanix.ProjectResourceDomainResourceArgs(
                    limit=4,
                    resource_type="STORAGE",
                )],
            ),
            default_subnet_reference=nutanix.ProjectDefaultSubnetReferenceArgs(
                uuid=subnet.metadata["uuid"],
            ),
            api_version="3.1")
        ```

        :param str resource_name: The name of the resource.
        :param ProjectArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProjectArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectAccountReferenceListArgs']]]]] = None,
                 api_version: Optional[pulumi.Input[str]] = None,
                 categories: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectCategoryArgs']]]]] = None,
                 default_subnet_reference: Optional[pulumi.Input[pulumi.InputType['ProjectDefaultSubnetReferenceArgs']]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 environment_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectEnvironmentReferenceListArgs']]]]] = None,
                 external_network_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectExternalNetworkListArgs']]]]] = None,
                 external_user_group_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectExternalUserGroupReferenceListArgs']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 owner_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 project_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 resource_domain: Optional[pulumi.Input[pulumi.InputType['ProjectResourceDomainArgs']]] = None,
                 subnet_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectSubnetReferenceListArgs']]]]] = None,
                 user_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectUserReferenceListArgs']]]]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProjectArgs.__new__(ProjectArgs)

            __props__.__dict__["account_reference_lists"] = account_reference_lists
            __props__.__dict__["api_version"] = api_version
            __props__.__dict__["categories"] = categories
            if default_subnet_reference is None and not opts.urn:
                raise TypeError("Missing required property 'default_subnet_reference'")
            __props__.__dict__["default_subnet_reference"] = default_subnet_reference
            if description is None and not opts.urn:
                raise TypeError("Missing required property 'description'")
            __props__.__dict__["description"] = description
            __props__.__dict__["environment_reference_lists"] = environment_reference_lists
            __props__.__dict__["external_network_lists"] = external_network_lists
            __props__.__dict__["external_user_group_reference_lists"] = external_user_group_reference_lists
            __props__.__dict__["name"] = name
            __props__.__dict__["owner_reference"] = owner_reference
            __props__.__dict__["project_reference"] = project_reference
            __props__.__dict__["resource_domain"] = resource_domain
            __props__.__dict__["subnet_reference_lists"] = subnet_reference_lists
            __props__.__dict__["user_reference_lists"] = user_reference_lists
            __props__.__dict__["is_default"] = None
            __props__.__dict__["metadata"] = None
            __props__.__dict__["state"] = None
        super(Project, __self__).__init__(
            'nutanix:index/project:Project',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            account_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectAccountReferenceListArgs']]]]] = None,
            api_version: Optional[pulumi.Input[str]] = None,
            categories: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectCategoryArgs']]]]] = None,
            default_subnet_reference: Optional[pulumi.Input[pulumi.InputType['ProjectDefaultSubnetReferenceArgs']]] = None,
            description: Optional[pulumi.Input[str]] = None,
            environment_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectEnvironmentReferenceListArgs']]]]] = None,
            external_network_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectExternalNetworkListArgs']]]]] = None,
            external_user_group_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectExternalUserGroupReferenceListArgs']]]]] = None,
            is_default: Optional[pulumi.Input[bool]] = None,
            metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            owner_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            project_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            resource_domain: Optional[pulumi.Input[pulumi.InputType['ProjectResourceDomainArgs']]] = None,
            state: Optional[pulumi.Input[str]] = None,
            subnet_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectSubnetReferenceListArgs']]]]] = None,
            user_reference_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectUserReferenceListArgs']]]]] = None) -> 'Project':
        """
        Get an existing Project resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectAccountReferenceListArgs']]]] account_reference_lists: List of accounts associated with the project.
               * `account_reference_list.#.kind` - (Optional) The kind name. Default value is `account`
               * `account_reference_list.#.uuid` - (Required) The UUID of an account.
               * `account_reference_list.#.name` - (Optional/Computed) The name of an account.
        :param pulumi.Input[pulumi.InputType['ProjectDefaultSubnetReferenceArgs']] default_subnet_reference: Reference to a subnet.
               * `default_subnet_reference.kind` - (Optional) The kind name. Default value is `subnet`
               * `default_subnet_reference.uuid` - (Required) The UUID of a subnet.
               * `default_subnet_reference.name` - (Optional/Computed) The name of a subnet.
        :param pulumi.Input[str] description: A description for project.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectEnvironmentReferenceListArgs']]]] environment_reference_lists: List of environments associated with the project.
               * `environment_reference_list.#.kind` - (Optional) The kind name. Default value is `environment`
               * `environment_reference_list.#.uuid` - (Required) The UUID of an environment.
               * `environment_reference_list.#.name` - (Optional/Computed) The name of an environment.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectExternalNetworkListArgs']]]] external_network_lists: List of external networks associated with the project.
               * `external_network_list.#.uuid` - (Required) The UUID of a network.
               * `external_network_list.#.name` - (Optional/Computed) The name of a network.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectExternalUserGroupReferenceListArgs']]]] external_user_group_reference_lists: List of directory service user groups. These groups are not managed by Nutanix.
               * `external_user_group_reference_list.#.kind` - (Optional) The kind name. Default value is `user_group`
               * `external_user_group_reference_list.#.uuid` - (Required) The UUID of a user_group
               * `external_user_group_reference_list.#.name` - (Optional/Computed) The name of a user_group
        :param pulumi.Input[str] name: The name for the project.
        :param pulumi.Input[pulumi.InputType['ProjectResourceDomainArgs']] resource_domain: The status for a resource domain (limits and values)
               * `resource_domain.resources` - (Required) Array of the utilization/limit for resource types
               * `resource_domain.resources.#.limit` - (Required) The resource consumption limit (unspecified is unlimited)
               * `resource_domain.resources.#.resource_type` - (Required) The type of resource (for example storage, CPUs)
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectSubnetReferenceListArgs']]]] subnet_reference_lists: List of subnets for the project.
               * `subnet_reference_list.#.kind` - (Optional) The kind name. Default value is `subnet`
               * `subnet_reference_list.#.uuid` - (Required) The UUID of a subnet
               * `subnet_reference_list.#.name` - (Optional/Computed) The name of a subnet.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProjectUserReferenceListArgs']]]] user_reference_lists: List of users in the project.
               * `user_reference_list.#.kind` - (Optional) The kind name. Default value is `user`
               * `user_reference_list.#.uuid` - (Required) The UUID of a user
               * `user_reference_list.#.name` - (Optional/Computed) The name of a user.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ProjectState.__new__(_ProjectState)

        __props__.__dict__["account_reference_lists"] = account_reference_lists
        __props__.__dict__["api_version"] = api_version
        __props__.__dict__["categories"] = categories
        __props__.__dict__["default_subnet_reference"] = default_subnet_reference
        __props__.__dict__["description"] = description
        __props__.__dict__["environment_reference_lists"] = environment_reference_lists
        __props__.__dict__["external_network_lists"] = external_network_lists
        __props__.__dict__["external_user_group_reference_lists"] = external_user_group_reference_lists
        __props__.__dict__["is_default"] = is_default
        __props__.__dict__["metadata"] = metadata
        __props__.__dict__["name"] = name
        __props__.__dict__["owner_reference"] = owner_reference
        __props__.__dict__["project_reference"] = project_reference
        __props__.__dict__["resource_domain"] = resource_domain
        __props__.__dict__["state"] = state
        __props__.__dict__["subnet_reference_lists"] = subnet_reference_lists
        __props__.__dict__["user_reference_lists"] = user_reference_lists
        return Project(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accountReferenceLists")
    def account_reference_lists(self) -> pulumi.Output[Sequence['outputs.ProjectAccountReferenceList']]:
        """
        List of accounts associated with the project.
        * `account_reference_list.#.kind` - (Optional) The kind name. Default value is `account`
        * `account_reference_list.#.uuid` - (Required) The UUID of an account.
        * `account_reference_list.#.name` - (Optional/Computed) The name of an account.
        """
        return pulumi.get(self, "account_reference_lists")

    @property
    @pulumi.getter(name="apiVersion")
    def api_version(self) -> pulumi.Output[str]:
        return pulumi.get(self, "api_version")

    @property
    @pulumi.getter
    def categories(self) -> pulumi.Output[Sequence['outputs.ProjectCategory']]:
        return pulumi.get(self, "categories")

    @property
    @pulumi.getter(name="defaultSubnetReference")
    def default_subnet_reference(self) -> pulumi.Output['outputs.ProjectDefaultSubnetReference']:
        """
        Reference to a subnet.
        * `default_subnet_reference.kind` - (Optional) The kind name. Default value is `subnet`
        * `default_subnet_reference.uuid` - (Required) The UUID of a subnet.
        * `default_subnet_reference.name` - (Optional/Computed) The name of a subnet.
        """
        return pulumi.get(self, "default_subnet_reference")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[str]:
        """
        A description for project.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="environmentReferenceLists")
    def environment_reference_lists(self) -> pulumi.Output[Sequence['outputs.ProjectEnvironmentReferenceList']]:
        """
        List of environments associated with the project.
        * `environment_reference_list.#.kind` - (Optional) The kind name. Default value is `environment`
        * `environment_reference_list.#.uuid` - (Required) The UUID of an environment.
        * `environment_reference_list.#.name` - (Optional/Computed) The name of an environment.
        """
        return pulumi.get(self, "environment_reference_lists")

    @property
    @pulumi.getter(name="externalNetworkLists")
    def external_network_lists(self) -> pulumi.Output[Sequence['outputs.ProjectExternalNetworkList']]:
        """
        List of external networks associated with the project.
        * `external_network_list.#.uuid` - (Required) The UUID of a network.
        * `external_network_list.#.name` - (Optional/Computed) The name of a network.
        """
        return pulumi.get(self, "external_network_lists")

    @property
    @pulumi.getter(name="externalUserGroupReferenceLists")
    def external_user_group_reference_lists(self) -> pulumi.Output[Sequence['outputs.ProjectExternalUserGroupReferenceList']]:
        """
        List of directory service user groups. These groups are not managed by Nutanix.
        * `external_user_group_reference_list.#.kind` - (Optional) The kind name. Default value is `user_group`
        * `external_user_group_reference_list.#.uuid` - (Required) The UUID of a user_group
        * `external_user_group_reference_list.#.name` - (Optional/Computed) The name of a user_group
        """
        return pulumi.get(self, "external_user_group_reference_lists")

    @property
    @pulumi.getter(name="isDefault")
    def is_default(self) -> pulumi.Output[bool]:
        return pulumi.get(self, "is_default")

    @property
    @pulumi.getter
    def metadata(self) -> pulumi.Output[Mapping[str, str]]:
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name for the project.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="ownerReference")
    def owner_reference(self) -> pulumi.Output[Mapping[str, str]]:
        return pulumi.get(self, "owner_reference")

    @property
    @pulumi.getter(name="projectReference")
    def project_reference(self) -> pulumi.Output[Mapping[str, str]]:
        return pulumi.get(self, "project_reference")

    @property
    @pulumi.getter(name="resourceDomain")
    def resource_domain(self) -> pulumi.Output[Optional['outputs.ProjectResourceDomain']]:
        """
        The status for a resource domain (limits and values)
        * `resource_domain.resources` - (Required) Array of the utilization/limit for resource types
        * `resource_domain.resources.#.limit` - (Required) The resource consumption limit (unspecified is unlimited)
        * `resource_domain.resources.#.resource_type` - (Required) The type of resource (for example storage, CPUs)
        """
        return pulumi.get(self, "resource_domain")

    @property
    @pulumi.getter
    def state(self) -> pulumi.Output[str]:
        return pulumi.get(self, "state")

    @property
    @pulumi.getter(name="subnetReferenceLists")
    def subnet_reference_lists(self) -> pulumi.Output[Sequence['outputs.ProjectSubnetReferenceList']]:
        """
        List of subnets for the project.
        * `subnet_reference_list.#.kind` - (Optional) The kind name. Default value is `subnet`
        * `subnet_reference_list.#.uuid` - (Required) The UUID of a subnet
        * `subnet_reference_list.#.name` - (Optional/Computed) The name of a subnet.
        """
        return pulumi.get(self, "subnet_reference_lists")

    @property
    @pulumi.getter(name="userReferenceLists")
    def user_reference_lists(self) -> pulumi.Output[Sequence['outputs.ProjectUserReferenceList']]:
        """
        List of users in the project.
        * `user_reference_list.#.kind` - (Optional) The kind name. Default value is `user`
        * `user_reference_list.#.uuid` - (Required) The UUID of a user
        * `user_reference_list.#.name` - (Optional/Computed) The name of a user.
        """
        return pulumi.get(self, "user_reference_lists")

