# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['ProviderArgs', 'Provider']

@pulumi.input_type
class ProviderArgs:
    def __init__(__self__, *,
                 endpoint: Optional[pulumi.Input[str]] = None,
                 foundation_endpoint: Optional[pulumi.Input[str]] = None,
                 foundation_port: Optional[pulumi.Input[str]] = None,
                 insecure: Optional[pulumi.Input[bool]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 port: Optional[pulumi.Input[str]] = None,
                 proxy_url: Optional[pulumi.Input[str]] = None,
                 session_auth: Optional[pulumi.Input[bool]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 wait_timeout: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a Provider resource.
        :param pulumi.Input[str] endpoint: URL for Nutanix Prism (e.g IP or FQDN for cluster VIP note, this is never the data services VIP, and should not be an
               individual CVM address, as this would cause calls to fail during cluster lifecycle management operations, such as AOS
               upgrades.
        :param pulumi.Input[str] foundation_endpoint: endpoint for foundation VM (eg. Foundation VM IP)
        :param pulumi.Input[str] foundation_port: Port for foundation VM
        :param pulumi.Input[bool] insecure: Explicitly allow the provider to perform "insecure" SSL requests. If omitted,default value is `false`
        :param pulumi.Input[str] password: Password for provided user name.
        :param pulumi.Input[str] port: Port for Nutanix Prism.
        :param pulumi.Input[bool] session_auth: Use session authentification instead of basic auth for each request
        :param pulumi.Input[str] username: User name for Nutanix Prism. Could be local cluster auth (e.g. 'admin') or directory auth.
        :param pulumi.Input[int] wait_timeout: Set if you know that the creation o update of a resource may take long time (minutes)
        """
        if endpoint is not None:
            pulumi.set(__self__, "endpoint", endpoint)
        if foundation_endpoint is not None:
            pulumi.set(__self__, "foundation_endpoint", foundation_endpoint)
        if foundation_port is not None:
            pulumi.set(__self__, "foundation_port", foundation_port)
        if insecure is not None:
            pulumi.set(__self__, "insecure", insecure)
        if password is not None:
            pulumi.set(__self__, "password", password)
        if port is not None:
            pulumi.set(__self__, "port", port)
        if proxy_url is not None:
            pulumi.set(__self__, "proxy_url", proxy_url)
        if session_auth is not None:
            pulumi.set(__self__, "session_auth", session_auth)
        if username is not None:
            pulumi.set(__self__, "username", username)
        if wait_timeout is not None:
            pulumi.set(__self__, "wait_timeout", wait_timeout)

    @property
    @pulumi.getter
    def endpoint(self) -> Optional[pulumi.Input[str]]:
        """
        URL for Nutanix Prism (e.g IP or FQDN for cluster VIP note, this is never the data services VIP, and should not be an
        individual CVM address, as this would cause calls to fail during cluster lifecycle management operations, such as AOS
        upgrades.
        """
        return pulumi.get(self, "endpoint")

    @endpoint.setter
    def endpoint(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "endpoint", value)

    @property
    @pulumi.getter(name="foundationEndpoint")
    def foundation_endpoint(self) -> Optional[pulumi.Input[str]]:
        """
        endpoint for foundation VM (eg. Foundation VM IP)
        """
        return pulumi.get(self, "foundation_endpoint")

    @foundation_endpoint.setter
    def foundation_endpoint(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "foundation_endpoint", value)

    @property
    @pulumi.getter(name="foundationPort")
    def foundation_port(self) -> Optional[pulumi.Input[str]]:
        """
        Port for foundation VM
        """
        return pulumi.get(self, "foundation_port")

    @foundation_port.setter
    def foundation_port(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "foundation_port", value)

    @property
    @pulumi.getter
    def insecure(self) -> Optional[pulumi.Input[bool]]:
        """
        Explicitly allow the provider to perform "insecure" SSL requests. If omitted,default value is `false`
        """
        return pulumi.get(self, "insecure")

    @insecure.setter
    def insecure(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "insecure", value)

    @property
    @pulumi.getter
    def password(self) -> Optional[pulumi.Input[str]]:
        """
        Password for provided user name.
        """
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter
    def port(self) -> Optional[pulumi.Input[str]]:
        """
        Port for Nutanix Prism.
        """
        return pulumi.get(self, "port")

    @port.setter
    def port(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "port", value)

    @property
    @pulumi.getter(name="proxyUrl")
    def proxy_url(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "proxy_url")

    @proxy_url.setter
    def proxy_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "proxy_url", value)

    @property
    @pulumi.getter(name="sessionAuth")
    def session_auth(self) -> Optional[pulumi.Input[bool]]:
        """
        Use session authentification instead of basic auth for each request
        """
        return pulumi.get(self, "session_auth")

    @session_auth.setter
    def session_auth(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "session_auth", value)

    @property
    @pulumi.getter
    def username(self) -> Optional[pulumi.Input[str]]:
        """
        User name for Nutanix Prism. Could be local cluster auth (e.g. 'admin') or directory auth.
        """
        return pulumi.get(self, "username")

    @username.setter
    def username(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "username", value)

    @property
    @pulumi.getter(name="waitTimeout")
    def wait_timeout(self) -> Optional[pulumi.Input[int]]:
        """
        Set if you know that the creation o update of a resource may take long time (minutes)
        """
        return pulumi.get(self, "wait_timeout")

    @wait_timeout.setter
    def wait_timeout(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "wait_timeout", value)


class Provider(pulumi.ProviderResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 endpoint: Optional[pulumi.Input[str]] = None,
                 foundation_endpoint: Optional[pulumi.Input[str]] = None,
                 foundation_port: Optional[pulumi.Input[str]] = None,
                 insecure: Optional[pulumi.Input[bool]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 port: Optional[pulumi.Input[str]] = None,
                 proxy_url: Optional[pulumi.Input[str]] = None,
                 session_auth: Optional[pulumi.Input[bool]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 wait_timeout: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        The provider type for the nutanix package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] endpoint: URL for Nutanix Prism (e.g IP or FQDN for cluster VIP note, this is never the data services VIP, and should not be an
               individual CVM address, as this would cause calls to fail during cluster lifecycle management operations, such as AOS
               upgrades.
        :param pulumi.Input[str] foundation_endpoint: endpoint for foundation VM (eg. Foundation VM IP)
        :param pulumi.Input[str] foundation_port: Port for foundation VM
        :param pulumi.Input[bool] insecure: Explicitly allow the provider to perform "insecure" SSL requests. If omitted,default value is `false`
        :param pulumi.Input[str] password: Password for provided user name.
        :param pulumi.Input[str] port: Port for Nutanix Prism.
        :param pulumi.Input[bool] session_auth: Use session authentification instead of basic auth for each request
        :param pulumi.Input[str] username: User name for Nutanix Prism. Could be local cluster auth (e.g. 'admin') or directory auth.
        :param pulumi.Input[int] wait_timeout: Set if you know that the creation o update of a resource may take long time (minutes)
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ProviderArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The provider type for the nutanix package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param ProviderArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProviderArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 endpoint: Optional[pulumi.Input[str]] = None,
                 foundation_endpoint: Optional[pulumi.Input[str]] = None,
                 foundation_port: Optional[pulumi.Input[str]] = None,
                 insecure: Optional[pulumi.Input[bool]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 port: Optional[pulumi.Input[str]] = None,
                 proxy_url: Optional[pulumi.Input[str]] = None,
                 session_auth: Optional[pulumi.Input[bool]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 wait_timeout: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProviderArgs.__new__(ProviderArgs)

            __props__.__dict__["endpoint"] = endpoint
            __props__.__dict__["foundation_endpoint"] = foundation_endpoint
            __props__.__dict__["foundation_port"] = foundation_port
            __props__.__dict__["insecure"] = pulumi.Output.from_input(insecure).apply(pulumi.runtime.to_json) if insecure is not None else None
            __props__.__dict__["password"] = password
            __props__.__dict__["port"] = port
            __props__.__dict__["proxy_url"] = proxy_url
            __props__.__dict__["session_auth"] = pulumi.Output.from_input(session_auth).apply(pulumi.runtime.to_json) if session_auth is not None else None
            __props__.__dict__["username"] = username
            __props__.__dict__["wait_timeout"] = pulumi.Output.from_input(wait_timeout).apply(pulumi.runtime.to_json) if wait_timeout is not None else None
        super(Provider, __self__).__init__(
            'nutanix',
            resource_name,
            __props__,
            opts)

    @property
    @pulumi.getter
    def endpoint(self) -> pulumi.Output[Optional[str]]:
        """
        URL for Nutanix Prism (e.g IP or FQDN for cluster VIP note, this is never the data services VIP, and should not be an
        individual CVM address, as this would cause calls to fail during cluster lifecycle management operations, such as AOS
        upgrades.
        """
        return pulumi.get(self, "endpoint")

    @property
    @pulumi.getter(name="foundationEndpoint")
    def foundation_endpoint(self) -> pulumi.Output[Optional[str]]:
        """
        endpoint for foundation VM (eg. Foundation VM IP)
        """
        return pulumi.get(self, "foundation_endpoint")

    @property
    @pulumi.getter(name="foundationPort")
    def foundation_port(self) -> pulumi.Output[Optional[str]]:
        """
        Port for foundation VM
        """
        return pulumi.get(self, "foundation_port")

    @property
    @pulumi.getter
    def password(self) -> pulumi.Output[Optional[str]]:
        """
        Password for provided user name.
        """
        return pulumi.get(self, "password")

    @property
    @pulumi.getter
    def port(self) -> pulumi.Output[Optional[str]]:
        """
        Port for Nutanix Prism.
        """
        return pulumi.get(self, "port")

    @property
    @pulumi.getter(name="proxyUrl")
    def proxy_url(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "proxy_url")

    @property
    @pulumi.getter
    def username(self) -> pulumi.Output[Optional[str]]:
        """
        User name for Nutanix Prism. Could be local cluster auth (e.g. 'admin') or directory auth.
        """
        return pulumi.get(self, "username")

