# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['VirtualMachineArgs', 'VirtualMachine']

@pulumi.input_type
class VirtualMachineArgs:
    def __init__(__self__, *,
                 cluster_uuid: pulumi.Input[str],
                 availability_zone_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 boot_device_disk_address: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 boot_device_mac_address: Optional[pulumi.Input[str]] = None,
                 boot_device_order_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 boot_type: Optional[pulumi.Input[str]] = None,
                 categories: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineCategoryArgs']]]] = None,
                 cloud_init_cdrom_uuid: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 disk_lists: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineDiskListArgs']]]] = None,
                 enable_cpu_passthrough: Optional[pulumi.Input[bool]] = None,
                 enable_script_exec: Optional[pulumi.Input[bool]] = None,
                 gpu_lists: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineGpuListArgs']]]] = None,
                 guest_customization_cloud_init_custom_key_values: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 guest_customization_cloud_init_meta_data: Optional[pulumi.Input[str]] = None,
                 guest_customization_cloud_init_user_data: Optional[pulumi.Input[str]] = None,
                 guest_customization_is_overridable: Optional[pulumi.Input[bool]] = None,
                 guest_customization_sysprep: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 guest_customization_sysprep_custom_key_values: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 guest_os_id: Optional[pulumi.Input[str]] = None,
                 hardware_clock_timezone: Optional[pulumi.Input[str]] = None,
                 is_vcpu_hard_pinned: Optional[pulumi.Input[bool]] = None,
                 machine_type: Optional[pulumi.Input[str]] = None,
                 memory_size_mib: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 ngt_credentials: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 ngt_enabled_capability_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 nic_lists: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineNicListArgs']]]] = None,
                 num_sockets: Optional[pulumi.Input[int]] = None,
                 num_vcpus_per_socket: Optional[pulumi.Input[int]] = None,
                 num_vnuma_nodes: Optional[pulumi.Input[int]] = None,
                 nutanix_guest_tools: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 owner_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 parent_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 power_state_mechanism: Optional[pulumi.Input[str]] = None,
                 project_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 serial_port_lists: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineSerialPortListArgs']]]] = None,
                 should_fail_on_script_failure: Optional[pulumi.Input[bool]] = None,
                 use_hot_add: Optional[pulumi.Input[bool]] = None,
                 vga_console_enabled: Optional[pulumi.Input[bool]] = None):
        """
        The set of arguments for constructing a VirtualMachine resource.
        :param pulumi.Input[Sequence[pulumi.Input['VirtualMachineDiskListArgs']]] disk_lists: Disks attached to the VM.
               * `use_hot_add`: - (Optional) Use Hot Add when modifying VM resources. Passing value false will result in VM reboots. Default value is `true`.
               * `num_threads_per_core`: - (Optional) Number of threads per core.
               * `enable_cpu_passthrough`: - (Optional) Add true to enable CPU passthrough.
               * `is_vcpu_hard_pinned`: - (Optional) Add true to enable CPU pinning.
        :param pulumi.Input[str] guest_customization_cloud_init_meta_data: The contents of the meta_data configuration for cloud-init. This can be formatted as YAML or JSON. The value must be base64 encoded.
               * `guest_customization_cloud_init_custom_key_values`: - (Optional) Generic key value pair used for custom attributes in cloud init.
               * `guest_customization_is_overridable`: - (Optional) Flag to allow override of customization by deployer.
               * `guest_customization_sysprep`: - (Optional) VM guests may be customized at boot time using one of several different methods. Currently, cloud-init w/ ConfigDriveV2 (for Linux VMs) and Sysprep (for Windows VMs) are supported. Only ONE OF sysprep or cloud_init should be provided. Note that guest customization can currently only be set during VM creation. Attempting to change it after creation will result in an error. Additional properties can be specified. For example - in the context of VM template creation if \"override_script\" is set to \"True\" then the deployer can upload their own custom script.
               * `guest_customization_sysrep_custom_key_values`: - (Optional) Generic key value pair used for custom attributes in sysrep.
               * `should_fail_on_script_failure`: - (Optional)  Extra configs related to power state transition. Indicates whether to abort ngt shutdown/reboot if script fails.
               * `enable_script_exec`: - (Optional) Extra configs related to power state transition. Indicates whether to execute set script before ngt shutdown/reboot.
               * `power_state_mechanism`: - (Optional) Indicates the mechanism guiding the VM power state transition. Currently used for the transition to \"OFF\" state. Power state mechanism (ACPI/GUEST/HARD).
               * `vga_console_enabled`: - (Optional) Indicates whether VGA console should be enabled or not.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ngt_enabled_capability_lists: Application names that are enabled.
               * `num_vcpus_per_socket`: - (Optional) Number of vCPUs per socket.
               * `num_sockets`: - (Optional) Number of vCPU sockets.
               * `gpu_list`: - (Optional) GPUs attached to the VM.
               * `parent_referece`: - (Optional) Reference to an entity that the VM cloned from.
               * `memory_size_mib`: - (Optional) Memory size in MiB.
               * `boot_device_order_list`: - (Optional) Indicates the order of device types in which VM should try to boot from. If boot device order is not provided the system will decide appropriate boot device order.
               * `boot_device_disk_address`: - (Optional) Address of disk to boot from.
               * `boot_device_mac_address`: - (Optional) MAC address of nic to boot from.
               * `boot_type`: - (Optional) Indicates whether the VM should use Secure boot, UEFI boot or Legacy boot.If UEFI or; Secure boot is enabled then other legacy boot options (like boot_device and; boot_device_order_list) are ignored. Secure boot depends on UEFI boot, i.e. enabling; Secure boot means that UEFI boot is also enabled. The possible value are: UEFI", "LEGACY", "SECURE_BOOT".
               * `machine_type`: - Machine type for the VM. Machine type Q35 is required for secure boot and does not support IDE disks.
               * `hardware_clock_timezone`: - (Optional) VM's hardware clock timezone in IANA TZDB format (America/Los_Angeles).
               * `guest_customization_cloud_init_user_data`: - (Optional) The contents of the user_data configuration for cloud-init. This can be formatted as YAML, JSON, or could be a shell script. The value must be base64 encoded.
        """
        pulumi.set(__self__, "cluster_uuid", cluster_uuid)
        if availability_zone_reference is not None:
            pulumi.set(__self__, "availability_zone_reference", availability_zone_reference)
        if boot_device_disk_address is not None:
            pulumi.set(__self__, "boot_device_disk_address", boot_device_disk_address)
        if boot_device_mac_address is not None:
            pulumi.set(__self__, "boot_device_mac_address", boot_device_mac_address)
        if boot_device_order_lists is not None:
            pulumi.set(__self__, "boot_device_order_lists", boot_device_order_lists)
        if boot_type is not None:
            pulumi.set(__self__, "boot_type", boot_type)
        if categories is not None:
            pulumi.set(__self__, "categories", categories)
        if cloud_init_cdrom_uuid is not None:
            pulumi.set(__self__, "cloud_init_cdrom_uuid", cloud_init_cdrom_uuid)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if disk_lists is not None:
            pulumi.set(__self__, "disk_lists", disk_lists)
        if enable_cpu_passthrough is not None:
            pulumi.set(__self__, "enable_cpu_passthrough", enable_cpu_passthrough)
        if enable_script_exec is not None:
            pulumi.set(__self__, "enable_script_exec", enable_script_exec)
        if gpu_lists is not None:
            pulumi.set(__self__, "gpu_lists", gpu_lists)
        if guest_customization_cloud_init_custom_key_values is not None:
            pulumi.set(__self__, "guest_customization_cloud_init_custom_key_values", guest_customization_cloud_init_custom_key_values)
        if guest_customization_cloud_init_meta_data is not None:
            pulumi.set(__self__, "guest_customization_cloud_init_meta_data", guest_customization_cloud_init_meta_data)
        if guest_customization_cloud_init_user_data is not None:
            pulumi.set(__self__, "guest_customization_cloud_init_user_data", guest_customization_cloud_init_user_data)
        if guest_customization_is_overridable is not None:
            pulumi.set(__self__, "guest_customization_is_overridable", guest_customization_is_overridable)
        if guest_customization_sysprep is not None:
            pulumi.set(__self__, "guest_customization_sysprep", guest_customization_sysprep)
        if guest_customization_sysprep_custom_key_values is not None:
            pulumi.set(__self__, "guest_customization_sysprep_custom_key_values", guest_customization_sysprep_custom_key_values)
        if guest_os_id is not None:
            pulumi.set(__self__, "guest_os_id", guest_os_id)
        if hardware_clock_timezone is not None:
            pulumi.set(__self__, "hardware_clock_timezone", hardware_clock_timezone)
        if is_vcpu_hard_pinned is not None:
            pulumi.set(__self__, "is_vcpu_hard_pinned", is_vcpu_hard_pinned)
        if machine_type is not None:
            pulumi.set(__self__, "machine_type", machine_type)
        if memory_size_mib is not None:
            pulumi.set(__self__, "memory_size_mib", memory_size_mib)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if ngt_credentials is not None:
            pulumi.set(__self__, "ngt_credentials", ngt_credentials)
        if ngt_enabled_capability_lists is not None:
            pulumi.set(__self__, "ngt_enabled_capability_lists", ngt_enabled_capability_lists)
        if nic_lists is not None:
            pulumi.set(__self__, "nic_lists", nic_lists)
        if num_sockets is not None:
            pulumi.set(__self__, "num_sockets", num_sockets)
        if num_vcpus_per_socket is not None:
            pulumi.set(__self__, "num_vcpus_per_socket", num_vcpus_per_socket)
        if num_vnuma_nodes is not None:
            pulumi.set(__self__, "num_vnuma_nodes", num_vnuma_nodes)
        if nutanix_guest_tools is not None:
            pulumi.set(__self__, "nutanix_guest_tools", nutanix_guest_tools)
        if owner_reference is not None:
            pulumi.set(__self__, "owner_reference", owner_reference)
        if parent_reference is not None:
            pulumi.set(__self__, "parent_reference", parent_reference)
        if power_state_mechanism is not None:
            pulumi.set(__self__, "power_state_mechanism", power_state_mechanism)
        if project_reference is not None:
            pulumi.set(__self__, "project_reference", project_reference)
        if serial_port_lists is not None:
            pulumi.set(__self__, "serial_port_lists", serial_port_lists)
        if should_fail_on_script_failure is not None:
            pulumi.set(__self__, "should_fail_on_script_failure", should_fail_on_script_failure)
        if use_hot_add is not None:
            pulumi.set(__self__, "use_hot_add", use_hot_add)
        if vga_console_enabled is not None:
            pulumi.set(__self__, "vga_console_enabled", vga_console_enabled)

    @property
    @pulumi.getter(name="clusterUuid")
    def cluster_uuid(self) -> pulumi.Input[str]:
        return pulumi.get(self, "cluster_uuid")

    @cluster_uuid.setter
    def cluster_uuid(self, value: pulumi.Input[str]):
        pulumi.set(self, "cluster_uuid", value)

    @property
    @pulumi.getter(name="availabilityZoneReference")
    def availability_zone_reference(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "availability_zone_reference")

    @availability_zone_reference.setter
    def availability_zone_reference(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "availability_zone_reference", value)

    @property
    @pulumi.getter(name="bootDeviceDiskAddress")
    def boot_device_disk_address(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "boot_device_disk_address")

    @boot_device_disk_address.setter
    def boot_device_disk_address(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "boot_device_disk_address", value)

    @property
    @pulumi.getter(name="bootDeviceMacAddress")
    def boot_device_mac_address(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "boot_device_mac_address")

    @boot_device_mac_address.setter
    def boot_device_mac_address(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "boot_device_mac_address", value)

    @property
    @pulumi.getter(name="bootDeviceOrderLists")
    def boot_device_order_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        return pulumi.get(self, "boot_device_order_lists")

    @boot_device_order_lists.setter
    def boot_device_order_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "boot_device_order_lists", value)

    @property
    @pulumi.getter(name="bootType")
    def boot_type(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "boot_type")

    @boot_type.setter
    def boot_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "boot_type", value)

    @property
    @pulumi.getter
    def categories(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineCategoryArgs']]]]:
        return pulumi.get(self, "categories")

    @categories.setter
    def categories(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineCategoryArgs']]]]):
        pulumi.set(self, "categories", value)

    @property
    @pulumi.getter(name="cloudInitCdromUuid")
    def cloud_init_cdrom_uuid(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "cloud_init_cdrom_uuid")

    @cloud_init_cdrom_uuid.setter
    def cloud_init_cdrom_uuid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cloud_init_cdrom_uuid", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="diskLists")
    def disk_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineDiskListArgs']]]]:
        """
        Disks attached to the VM.
        * `use_hot_add`: - (Optional) Use Hot Add when modifying VM resources. Passing value false will result in VM reboots. Default value is `true`.
        * `num_threads_per_core`: - (Optional) Number of threads per core.
        * `enable_cpu_passthrough`: - (Optional) Add true to enable CPU passthrough.
        * `is_vcpu_hard_pinned`: - (Optional) Add true to enable CPU pinning.
        """
        return pulumi.get(self, "disk_lists")

    @disk_lists.setter
    def disk_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineDiskListArgs']]]]):
        pulumi.set(self, "disk_lists", value)

    @property
    @pulumi.getter(name="enableCpuPassthrough")
    def enable_cpu_passthrough(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "enable_cpu_passthrough")

    @enable_cpu_passthrough.setter
    def enable_cpu_passthrough(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable_cpu_passthrough", value)

    @property
    @pulumi.getter(name="enableScriptExec")
    def enable_script_exec(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "enable_script_exec")

    @enable_script_exec.setter
    def enable_script_exec(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable_script_exec", value)

    @property
    @pulumi.getter(name="gpuLists")
    def gpu_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineGpuListArgs']]]]:
        return pulumi.get(self, "gpu_lists")

    @gpu_lists.setter
    def gpu_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineGpuListArgs']]]]):
        pulumi.set(self, "gpu_lists", value)

    @property
    @pulumi.getter(name="guestCustomizationCloudInitCustomKeyValues")
    def guest_customization_cloud_init_custom_key_values(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "guest_customization_cloud_init_custom_key_values")

    @guest_customization_cloud_init_custom_key_values.setter
    def guest_customization_cloud_init_custom_key_values(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "guest_customization_cloud_init_custom_key_values", value)

    @property
    @pulumi.getter(name="guestCustomizationCloudInitMetaData")
    def guest_customization_cloud_init_meta_data(self) -> Optional[pulumi.Input[str]]:
        """
        The contents of the meta_data configuration for cloud-init. This can be formatted as YAML or JSON. The value must be base64 encoded.
        * `guest_customization_cloud_init_custom_key_values`: - (Optional) Generic key value pair used for custom attributes in cloud init.
        * `guest_customization_is_overridable`: - (Optional) Flag to allow override of customization by deployer.
        * `guest_customization_sysprep`: - (Optional) VM guests may be customized at boot time using one of several different methods. Currently, cloud-init w/ ConfigDriveV2 (for Linux VMs) and Sysprep (for Windows VMs) are supported. Only ONE OF sysprep or cloud_init should be provided. Note that guest customization can currently only be set during VM creation. Attempting to change it after creation will result in an error. Additional properties can be specified. For example - in the context of VM template creation if \"override_script\" is set to \"True\" then the deployer can upload their own custom script.
        * `guest_customization_sysrep_custom_key_values`: - (Optional) Generic key value pair used for custom attributes in sysrep.
        * `should_fail_on_script_failure`: - (Optional)  Extra configs related to power state transition. Indicates whether to abort ngt shutdown/reboot if script fails.
        * `enable_script_exec`: - (Optional) Extra configs related to power state transition. Indicates whether to execute set script before ngt shutdown/reboot.
        * `power_state_mechanism`: - (Optional) Indicates the mechanism guiding the VM power state transition. Currently used for the transition to \"OFF\" state. Power state mechanism (ACPI/GUEST/HARD).
        * `vga_console_enabled`: - (Optional) Indicates whether VGA console should be enabled or not.
        """
        return pulumi.get(self, "guest_customization_cloud_init_meta_data")

    @guest_customization_cloud_init_meta_data.setter
    def guest_customization_cloud_init_meta_data(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "guest_customization_cloud_init_meta_data", value)

    @property
    @pulumi.getter(name="guestCustomizationCloudInitUserData")
    def guest_customization_cloud_init_user_data(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "guest_customization_cloud_init_user_data")

    @guest_customization_cloud_init_user_data.setter
    def guest_customization_cloud_init_user_data(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "guest_customization_cloud_init_user_data", value)

    @property
    @pulumi.getter(name="guestCustomizationIsOverridable")
    def guest_customization_is_overridable(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "guest_customization_is_overridable")

    @guest_customization_is_overridable.setter
    def guest_customization_is_overridable(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "guest_customization_is_overridable", value)

    @property
    @pulumi.getter(name="guestCustomizationSysprep")
    def guest_customization_sysprep(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "guest_customization_sysprep")

    @guest_customization_sysprep.setter
    def guest_customization_sysprep(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "guest_customization_sysprep", value)

    @property
    @pulumi.getter(name="guestCustomizationSysprepCustomKeyValues")
    def guest_customization_sysprep_custom_key_values(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        return pulumi.get(self, "guest_customization_sysprep_custom_key_values")

    @guest_customization_sysprep_custom_key_values.setter
    def guest_customization_sysprep_custom_key_values(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "guest_customization_sysprep_custom_key_values", value)

    @property
    @pulumi.getter(name="guestOsId")
    def guest_os_id(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "guest_os_id")

    @guest_os_id.setter
    def guest_os_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "guest_os_id", value)

    @property
    @pulumi.getter(name="hardwareClockTimezone")
    def hardware_clock_timezone(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "hardware_clock_timezone")

    @hardware_clock_timezone.setter
    def hardware_clock_timezone(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hardware_clock_timezone", value)

    @property
    @pulumi.getter(name="isVcpuHardPinned")
    def is_vcpu_hard_pinned(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "is_vcpu_hard_pinned")

    @is_vcpu_hard_pinned.setter
    def is_vcpu_hard_pinned(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_vcpu_hard_pinned", value)

    @property
    @pulumi.getter(name="machineType")
    def machine_type(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "machine_type")

    @machine_type.setter
    def machine_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "machine_type", value)

    @property
    @pulumi.getter(name="memorySizeMib")
    def memory_size_mib(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "memory_size_mib")

    @memory_size_mib.setter
    def memory_size_mib(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "memory_size_mib", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="ngtCredentials")
    def ngt_credentials(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        return pulumi.get(self, "ngt_credentials")

    @ngt_credentials.setter
    def ngt_credentials(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "ngt_credentials", value)

    @property
    @pulumi.getter(name="ngtEnabledCapabilityLists")
    def ngt_enabled_capability_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Application names that are enabled.
        * `num_vcpus_per_socket`: - (Optional) Number of vCPUs per socket.
        * `num_sockets`: - (Optional) Number of vCPU sockets.
        * `gpu_list`: - (Optional) GPUs attached to the VM.
        * `parent_referece`: - (Optional) Reference to an entity that the VM cloned from.
        * `memory_size_mib`: - (Optional) Memory size in MiB.
        * `boot_device_order_list`: - (Optional) Indicates the order of device types in which VM should try to boot from. If boot device order is not provided the system will decide appropriate boot device order.
        * `boot_device_disk_address`: - (Optional) Address of disk to boot from.
        * `boot_device_mac_address`: - (Optional) MAC address of nic to boot from.
        * `boot_type`: - (Optional) Indicates whether the VM should use Secure boot, UEFI boot or Legacy boot.If UEFI or; Secure boot is enabled then other legacy boot options (like boot_device and; boot_device_order_list) are ignored. Secure boot depends on UEFI boot, i.e. enabling; Secure boot means that UEFI boot is also enabled. The possible value are: UEFI", "LEGACY", "SECURE_BOOT".
        * `machine_type`: - Machine type for the VM. Machine type Q35 is required for secure boot and does not support IDE disks.
        * `hardware_clock_timezone`: - (Optional) VM's hardware clock timezone in IANA TZDB format (America/Los_Angeles).
        * `guest_customization_cloud_init_user_data`: - (Optional) The contents of the user_data configuration for cloud-init. This can be formatted as YAML, JSON, or could be a shell script. The value must be base64 encoded.
        """
        return pulumi.get(self, "ngt_enabled_capability_lists")

    @ngt_enabled_capability_lists.setter
    def ngt_enabled_capability_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "ngt_enabled_capability_lists", value)

    @property
    @pulumi.getter(name="nicLists")
    def nic_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineNicListArgs']]]]:
        return pulumi.get(self, "nic_lists")

    @nic_lists.setter
    def nic_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineNicListArgs']]]]):
        pulumi.set(self, "nic_lists", value)

    @property
    @pulumi.getter(name="numSockets")
    def num_sockets(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "num_sockets")

    @num_sockets.setter
    def num_sockets(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "num_sockets", value)

    @property
    @pulumi.getter(name="numVcpusPerSocket")
    def num_vcpus_per_socket(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "num_vcpus_per_socket")

    @num_vcpus_per_socket.setter
    def num_vcpus_per_socket(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "num_vcpus_per_socket", value)

    @property
    @pulumi.getter(name="numVnumaNodes")
    def num_vnuma_nodes(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "num_vnuma_nodes")

    @num_vnuma_nodes.setter
    def num_vnuma_nodes(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "num_vnuma_nodes", value)

    @property
    @pulumi.getter(name="nutanixGuestTools")
    def nutanix_guest_tools(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "nutanix_guest_tools")

    @nutanix_guest_tools.setter
    def nutanix_guest_tools(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "nutanix_guest_tools", value)

    @property
    @pulumi.getter(name="ownerReference")
    def owner_reference(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "owner_reference")

    @owner_reference.setter
    def owner_reference(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "owner_reference", value)

    @property
    @pulumi.getter(name="parentReference")
    def parent_reference(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "parent_reference")

    @parent_reference.setter
    def parent_reference(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "parent_reference", value)

    @property
    @pulumi.getter(name="powerStateMechanism")
    def power_state_mechanism(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "power_state_mechanism")

    @power_state_mechanism.setter
    def power_state_mechanism(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "power_state_mechanism", value)

    @property
    @pulumi.getter(name="projectReference")
    def project_reference(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "project_reference")

    @project_reference.setter
    def project_reference(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "project_reference", value)

    @property
    @pulumi.getter(name="serialPortLists")
    def serial_port_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineSerialPortListArgs']]]]:
        return pulumi.get(self, "serial_port_lists")

    @serial_port_lists.setter
    def serial_port_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineSerialPortListArgs']]]]):
        pulumi.set(self, "serial_port_lists", value)

    @property
    @pulumi.getter(name="shouldFailOnScriptFailure")
    def should_fail_on_script_failure(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "should_fail_on_script_failure")

    @should_fail_on_script_failure.setter
    def should_fail_on_script_failure(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "should_fail_on_script_failure", value)

    @property
    @pulumi.getter(name="useHotAdd")
    def use_hot_add(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "use_hot_add")

    @use_hot_add.setter
    def use_hot_add(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "use_hot_add", value)

    @property
    @pulumi.getter(name="vgaConsoleEnabled")
    def vga_console_enabled(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "vga_console_enabled")

    @vga_console_enabled.setter
    def vga_console_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "vga_console_enabled", value)


@pulumi.input_type
class _VirtualMachineState:
    def __init__(__self__, *,
                 api_version: Optional[pulumi.Input[str]] = None,
                 availability_zone_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 boot_device_disk_address: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 boot_device_mac_address: Optional[pulumi.Input[str]] = None,
                 boot_device_order_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 boot_type: Optional[pulumi.Input[str]] = None,
                 categories: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineCategoryArgs']]]] = None,
                 cloud_init_cdrom_uuid: Optional[pulumi.Input[str]] = None,
                 cluster_name: Optional[pulumi.Input[str]] = None,
                 cluster_uuid: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 disk_lists: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineDiskListArgs']]]] = None,
                 enable_cpu_passthrough: Optional[pulumi.Input[bool]] = None,
                 enable_script_exec: Optional[pulumi.Input[bool]] = None,
                 gpu_lists: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineGpuListArgs']]]] = None,
                 guest_customization_cloud_init_custom_key_values: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 guest_customization_cloud_init_meta_data: Optional[pulumi.Input[str]] = None,
                 guest_customization_cloud_init_user_data: Optional[pulumi.Input[str]] = None,
                 guest_customization_is_overridable: Optional[pulumi.Input[bool]] = None,
                 guest_customization_sysprep: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 guest_customization_sysprep_custom_key_values: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 guest_os_id: Optional[pulumi.Input[str]] = None,
                 hardware_clock_timezone: Optional[pulumi.Input[str]] = None,
                 host_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 hypervisor_type: Optional[pulumi.Input[str]] = None,
                 is_vcpu_hard_pinned: Optional[pulumi.Input[bool]] = None,
                 machine_type: Optional[pulumi.Input[str]] = None,
                 memory_size_mib: Optional[pulumi.Input[int]] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 ngt_credentials: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 ngt_enabled_capability_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 nic_list_statuses: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineNicListStatusArgs']]]] = None,
                 nic_lists: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineNicListArgs']]]] = None,
                 num_sockets: Optional[pulumi.Input[int]] = None,
                 num_vcpus_per_socket: Optional[pulumi.Input[int]] = None,
                 num_vnuma_nodes: Optional[pulumi.Input[int]] = None,
                 nutanix_guest_tools: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 owner_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 parent_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 power_state: Optional[pulumi.Input[str]] = None,
                 power_state_mechanism: Optional[pulumi.Input[str]] = None,
                 project_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 serial_port_lists: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineSerialPortListArgs']]]] = None,
                 should_fail_on_script_failure: Optional[pulumi.Input[bool]] = None,
                 state: Optional[pulumi.Input[str]] = None,
                 use_hot_add: Optional[pulumi.Input[bool]] = None,
                 vga_console_enabled: Optional[pulumi.Input[bool]] = None):
        """
        Input properties used for looking up and filtering VirtualMachine resources.
        :param pulumi.Input[str] api_version: The version of the API.
               * `state`: - The state of the vm.
               * `cluster_name`: - The name of the cluster.
               * `host_reference`: - Reference to a host.
               * `hypervisor_type`: - The hypervisor type for the hypervisor the VM is hosted on.
               * `nic_list_status`: - Status NICs attached to the VM.
        :param pulumi.Input[Sequence[pulumi.Input['VirtualMachineDiskListArgs']]] disk_lists: Disks attached to the VM.
               * `use_hot_add`: - (Optional) Use Hot Add when modifying VM resources. Passing value false will result in VM reboots. Default value is `true`.
               * `num_threads_per_core`: - (Optional) Number of threads per core.
               * `enable_cpu_passthrough`: - (Optional) Add true to enable CPU passthrough.
               * `is_vcpu_hard_pinned`: - (Optional) Add true to enable CPU pinning.
        :param pulumi.Input[str] guest_customization_cloud_init_meta_data: The contents of the meta_data configuration for cloud-init. This can be formatted as YAML or JSON. The value must be base64 encoded.
               * `guest_customization_cloud_init_custom_key_values`: - (Optional) Generic key value pair used for custom attributes in cloud init.
               * `guest_customization_is_overridable`: - (Optional) Flag to allow override of customization by deployer.
               * `guest_customization_sysprep`: - (Optional) VM guests may be customized at boot time using one of several different methods. Currently, cloud-init w/ ConfigDriveV2 (for Linux VMs) and Sysprep (for Windows VMs) are supported. Only ONE OF sysprep or cloud_init should be provided. Note that guest customization can currently only be set during VM creation. Attempting to change it after creation will result in an error. Additional properties can be specified. For example - in the context of VM template creation if \"override_script\" is set to \"True\" then the deployer can upload their own custom script.
               * `guest_customization_sysrep_custom_key_values`: - (Optional) Generic key value pair used for custom attributes in sysrep.
               * `should_fail_on_script_failure`: - (Optional)  Extra configs related to power state transition. Indicates whether to abort ngt shutdown/reboot if script fails.
               * `enable_script_exec`: - (Optional) Extra configs related to power state transition. Indicates whether to execute set script before ngt shutdown/reboot.
               * `power_state_mechanism`: - (Optional) Indicates the mechanism guiding the VM power state transition. Currently used for the transition to \"OFF\" state. Power state mechanism (ACPI/GUEST/HARD).
               * `vga_console_enabled`: - (Optional) Indicates whether VGA console should be enabled or not.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ngt_enabled_capability_lists: Application names that are enabled.
               * `num_vcpus_per_socket`: - (Optional) Number of vCPUs per socket.
               * `num_sockets`: - (Optional) Number of vCPU sockets.
               * `gpu_list`: - (Optional) GPUs attached to the VM.
               * `parent_referece`: - (Optional) Reference to an entity that the VM cloned from.
               * `memory_size_mib`: - (Optional) Memory size in MiB.
               * `boot_device_order_list`: - (Optional) Indicates the order of device types in which VM should try to boot from. If boot device order is not provided the system will decide appropriate boot device order.
               * `boot_device_disk_address`: - (Optional) Address of disk to boot from.
               * `boot_device_mac_address`: - (Optional) MAC address of nic to boot from.
               * `boot_type`: - (Optional) Indicates whether the VM should use Secure boot, UEFI boot or Legacy boot.If UEFI or; Secure boot is enabled then other legacy boot options (like boot_device and; boot_device_order_list) are ignored. Secure boot depends on UEFI boot, i.e. enabling; Secure boot means that UEFI boot is also enabled. The possible value are: UEFI", "LEGACY", "SECURE_BOOT".
               * `machine_type`: - Machine type for the VM. Machine type Q35 is required for secure boot and does not support IDE disks.
               * `hardware_clock_timezone`: - (Optional) VM's hardware clock timezone in IANA TZDB format (America/Los_Angeles).
               * `guest_customization_cloud_init_user_data`: - (Optional) The contents of the user_data configuration for cloud-init. This can be formatted as YAML, JSON, or could be a shell script. The value must be base64 encoded.
        """
        if api_version is not None:
            pulumi.set(__self__, "api_version", api_version)
        if availability_zone_reference is not None:
            pulumi.set(__self__, "availability_zone_reference", availability_zone_reference)
        if boot_device_disk_address is not None:
            pulumi.set(__self__, "boot_device_disk_address", boot_device_disk_address)
        if boot_device_mac_address is not None:
            pulumi.set(__self__, "boot_device_mac_address", boot_device_mac_address)
        if boot_device_order_lists is not None:
            pulumi.set(__self__, "boot_device_order_lists", boot_device_order_lists)
        if boot_type is not None:
            pulumi.set(__self__, "boot_type", boot_type)
        if categories is not None:
            pulumi.set(__self__, "categories", categories)
        if cloud_init_cdrom_uuid is not None:
            pulumi.set(__self__, "cloud_init_cdrom_uuid", cloud_init_cdrom_uuid)
        if cluster_name is not None:
            pulumi.set(__self__, "cluster_name", cluster_name)
        if cluster_uuid is not None:
            pulumi.set(__self__, "cluster_uuid", cluster_uuid)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if disk_lists is not None:
            pulumi.set(__self__, "disk_lists", disk_lists)
        if enable_cpu_passthrough is not None:
            pulumi.set(__self__, "enable_cpu_passthrough", enable_cpu_passthrough)
        if enable_script_exec is not None:
            pulumi.set(__self__, "enable_script_exec", enable_script_exec)
        if gpu_lists is not None:
            pulumi.set(__self__, "gpu_lists", gpu_lists)
        if guest_customization_cloud_init_custom_key_values is not None:
            pulumi.set(__self__, "guest_customization_cloud_init_custom_key_values", guest_customization_cloud_init_custom_key_values)
        if guest_customization_cloud_init_meta_data is not None:
            pulumi.set(__self__, "guest_customization_cloud_init_meta_data", guest_customization_cloud_init_meta_data)
        if guest_customization_cloud_init_user_data is not None:
            pulumi.set(__self__, "guest_customization_cloud_init_user_data", guest_customization_cloud_init_user_data)
        if guest_customization_is_overridable is not None:
            pulumi.set(__self__, "guest_customization_is_overridable", guest_customization_is_overridable)
        if guest_customization_sysprep is not None:
            pulumi.set(__self__, "guest_customization_sysprep", guest_customization_sysprep)
        if guest_customization_sysprep_custom_key_values is not None:
            pulumi.set(__self__, "guest_customization_sysprep_custom_key_values", guest_customization_sysprep_custom_key_values)
        if guest_os_id is not None:
            pulumi.set(__self__, "guest_os_id", guest_os_id)
        if hardware_clock_timezone is not None:
            pulumi.set(__self__, "hardware_clock_timezone", hardware_clock_timezone)
        if host_reference is not None:
            pulumi.set(__self__, "host_reference", host_reference)
        if hypervisor_type is not None:
            pulumi.set(__self__, "hypervisor_type", hypervisor_type)
        if is_vcpu_hard_pinned is not None:
            pulumi.set(__self__, "is_vcpu_hard_pinned", is_vcpu_hard_pinned)
        if machine_type is not None:
            pulumi.set(__self__, "machine_type", machine_type)
        if memory_size_mib is not None:
            pulumi.set(__self__, "memory_size_mib", memory_size_mib)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if ngt_credentials is not None:
            pulumi.set(__self__, "ngt_credentials", ngt_credentials)
        if ngt_enabled_capability_lists is not None:
            pulumi.set(__self__, "ngt_enabled_capability_lists", ngt_enabled_capability_lists)
        if nic_list_statuses is not None:
            pulumi.set(__self__, "nic_list_statuses", nic_list_statuses)
        if nic_lists is not None:
            pulumi.set(__self__, "nic_lists", nic_lists)
        if num_sockets is not None:
            pulumi.set(__self__, "num_sockets", num_sockets)
        if num_vcpus_per_socket is not None:
            pulumi.set(__self__, "num_vcpus_per_socket", num_vcpus_per_socket)
        if num_vnuma_nodes is not None:
            pulumi.set(__self__, "num_vnuma_nodes", num_vnuma_nodes)
        if nutanix_guest_tools is not None:
            pulumi.set(__self__, "nutanix_guest_tools", nutanix_guest_tools)
        if owner_reference is not None:
            pulumi.set(__self__, "owner_reference", owner_reference)
        if parent_reference is not None:
            pulumi.set(__self__, "parent_reference", parent_reference)
        if power_state is not None:
            pulumi.set(__self__, "power_state", power_state)
        if power_state_mechanism is not None:
            pulumi.set(__self__, "power_state_mechanism", power_state_mechanism)
        if project_reference is not None:
            pulumi.set(__self__, "project_reference", project_reference)
        if serial_port_lists is not None:
            pulumi.set(__self__, "serial_port_lists", serial_port_lists)
        if should_fail_on_script_failure is not None:
            pulumi.set(__self__, "should_fail_on_script_failure", should_fail_on_script_failure)
        if state is not None:
            pulumi.set(__self__, "state", state)
        if use_hot_add is not None:
            pulumi.set(__self__, "use_hot_add", use_hot_add)
        if vga_console_enabled is not None:
            pulumi.set(__self__, "vga_console_enabled", vga_console_enabled)

    @property
    @pulumi.getter(name="apiVersion")
    def api_version(self) -> Optional[pulumi.Input[str]]:
        """
        The version of the API.
        * `state`: - The state of the vm.
        * `cluster_name`: - The name of the cluster.
        * `host_reference`: - Reference to a host.
        * `hypervisor_type`: - The hypervisor type for the hypervisor the VM is hosted on.
        * `nic_list_status`: - Status NICs attached to the VM.
        """
        return pulumi.get(self, "api_version")

    @api_version.setter
    def api_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "api_version", value)

    @property
    @pulumi.getter(name="availabilityZoneReference")
    def availability_zone_reference(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "availability_zone_reference")

    @availability_zone_reference.setter
    def availability_zone_reference(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "availability_zone_reference", value)

    @property
    @pulumi.getter(name="bootDeviceDiskAddress")
    def boot_device_disk_address(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "boot_device_disk_address")

    @boot_device_disk_address.setter
    def boot_device_disk_address(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "boot_device_disk_address", value)

    @property
    @pulumi.getter(name="bootDeviceMacAddress")
    def boot_device_mac_address(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "boot_device_mac_address")

    @boot_device_mac_address.setter
    def boot_device_mac_address(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "boot_device_mac_address", value)

    @property
    @pulumi.getter(name="bootDeviceOrderLists")
    def boot_device_order_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        return pulumi.get(self, "boot_device_order_lists")

    @boot_device_order_lists.setter
    def boot_device_order_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "boot_device_order_lists", value)

    @property
    @pulumi.getter(name="bootType")
    def boot_type(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "boot_type")

    @boot_type.setter
    def boot_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "boot_type", value)

    @property
    @pulumi.getter
    def categories(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineCategoryArgs']]]]:
        return pulumi.get(self, "categories")

    @categories.setter
    def categories(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineCategoryArgs']]]]):
        pulumi.set(self, "categories", value)

    @property
    @pulumi.getter(name="cloudInitCdromUuid")
    def cloud_init_cdrom_uuid(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "cloud_init_cdrom_uuid")

    @cloud_init_cdrom_uuid.setter
    def cloud_init_cdrom_uuid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cloud_init_cdrom_uuid", value)

    @property
    @pulumi.getter(name="clusterName")
    def cluster_name(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "cluster_name")

    @cluster_name.setter
    def cluster_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cluster_name", value)

    @property
    @pulumi.getter(name="clusterUuid")
    def cluster_uuid(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "cluster_uuid")

    @cluster_uuid.setter
    def cluster_uuid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cluster_uuid", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="diskLists")
    def disk_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineDiskListArgs']]]]:
        """
        Disks attached to the VM.
        * `use_hot_add`: - (Optional) Use Hot Add when modifying VM resources. Passing value false will result in VM reboots. Default value is `true`.
        * `num_threads_per_core`: - (Optional) Number of threads per core.
        * `enable_cpu_passthrough`: - (Optional) Add true to enable CPU passthrough.
        * `is_vcpu_hard_pinned`: - (Optional) Add true to enable CPU pinning.
        """
        return pulumi.get(self, "disk_lists")

    @disk_lists.setter
    def disk_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineDiskListArgs']]]]):
        pulumi.set(self, "disk_lists", value)

    @property
    @pulumi.getter(name="enableCpuPassthrough")
    def enable_cpu_passthrough(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "enable_cpu_passthrough")

    @enable_cpu_passthrough.setter
    def enable_cpu_passthrough(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable_cpu_passthrough", value)

    @property
    @pulumi.getter(name="enableScriptExec")
    def enable_script_exec(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "enable_script_exec")

    @enable_script_exec.setter
    def enable_script_exec(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable_script_exec", value)

    @property
    @pulumi.getter(name="gpuLists")
    def gpu_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineGpuListArgs']]]]:
        return pulumi.get(self, "gpu_lists")

    @gpu_lists.setter
    def gpu_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineGpuListArgs']]]]):
        pulumi.set(self, "gpu_lists", value)

    @property
    @pulumi.getter(name="guestCustomizationCloudInitCustomKeyValues")
    def guest_customization_cloud_init_custom_key_values(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "guest_customization_cloud_init_custom_key_values")

    @guest_customization_cloud_init_custom_key_values.setter
    def guest_customization_cloud_init_custom_key_values(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "guest_customization_cloud_init_custom_key_values", value)

    @property
    @pulumi.getter(name="guestCustomizationCloudInitMetaData")
    def guest_customization_cloud_init_meta_data(self) -> Optional[pulumi.Input[str]]:
        """
        The contents of the meta_data configuration for cloud-init. This can be formatted as YAML or JSON. The value must be base64 encoded.
        * `guest_customization_cloud_init_custom_key_values`: - (Optional) Generic key value pair used for custom attributes in cloud init.
        * `guest_customization_is_overridable`: - (Optional) Flag to allow override of customization by deployer.
        * `guest_customization_sysprep`: - (Optional) VM guests may be customized at boot time using one of several different methods. Currently, cloud-init w/ ConfigDriveV2 (for Linux VMs) and Sysprep (for Windows VMs) are supported. Only ONE OF sysprep or cloud_init should be provided. Note that guest customization can currently only be set during VM creation. Attempting to change it after creation will result in an error. Additional properties can be specified. For example - in the context of VM template creation if \"override_script\" is set to \"True\" then the deployer can upload their own custom script.
        * `guest_customization_sysrep_custom_key_values`: - (Optional) Generic key value pair used for custom attributes in sysrep.
        * `should_fail_on_script_failure`: - (Optional)  Extra configs related to power state transition. Indicates whether to abort ngt shutdown/reboot if script fails.
        * `enable_script_exec`: - (Optional) Extra configs related to power state transition. Indicates whether to execute set script before ngt shutdown/reboot.
        * `power_state_mechanism`: - (Optional) Indicates the mechanism guiding the VM power state transition. Currently used for the transition to \"OFF\" state. Power state mechanism (ACPI/GUEST/HARD).
        * `vga_console_enabled`: - (Optional) Indicates whether VGA console should be enabled or not.
        """
        return pulumi.get(self, "guest_customization_cloud_init_meta_data")

    @guest_customization_cloud_init_meta_data.setter
    def guest_customization_cloud_init_meta_data(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "guest_customization_cloud_init_meta_data", value)

    @property
    @pulumi.getter(name="guestCustomizationCloudInitUserData")
    def guest_customization_cloud_init_user_data(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "guest_customization_cloud_init_user_data")

    @guest_customization_cloud_init_user_data.setter
    def guest_customization_cloud_init_user_data(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "guest_customization_cloud_init_user_data", value)

    @property
    @pulumi.getter(name="guestCustomizationIsOverridable")
    def guest_customization_is_overridable(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "guest_customization_is_overridable")

    @guest_customization_is_overridable.setter
    def guest_customization_is_overridable(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "guest_customization_is_overridable", value)

    @property
    @pulumi.getter(name="guestCustomizationSysprep")
    def guest_customization_sysprep(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "guest_customization_sysprep")

    @guest_customization_sysprep.setter
    def guest_customization_sysprep(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "guest_customization_sysprep", value)

    @property
    @pulumi.getter(name="guestCustomizationSysprepCustomKeyValues")
    def guest_customization_sysprep_custom_key_values(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        return pulumi.get(self, "guest_customization_sysprep_custom_key_values")

    @guest_customization_sysprep_custom_key_values.setter
    def guest_customization_sysprep_custom_key_values(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "guest_customization_sysprep_custom_key_values", value)

    @property
    @pulumi.getter(name="guestOsId")
    def guest_os_id(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "guest_os_id")

    @guest_os_id.setter
    def guest_os_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "guest_os_id", value)

    @property
    @pulumi.getter(name="hardwareClockTimezone")
    def hardware_clock_timezone(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "hardware_clock_timezone")

    @hardware_clock_timezone.setter
    def hardware_clock_timezone(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hardware_clock_timezone", value)

    @property
    @pulumi.getter(name="hostReference")
    def host_reference(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "host_reference")

    @host_reference.setter
    def host_reference(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "host_reference", value)

    @property
    @pulumi.getter(name="hypervisorType")
    def hypervisor_type(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "hypervisor_type")

    @hypervisor_type.setter
    def hypervisor_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hypervisor_type", value)

    @property
    @pulumi.getter(name="isVcpuHardPinned")
    def is_vcpu_hard_pinned(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "is_vcpu_hard_pinned")

    @is_vcpu_hard_pinned.setter
    def is_vcpu_hard_pinned(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_vcpu_hard_pinned", value)

    @property
    @pulumi.getter(name="machineType")
    def machine_type(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "machine_type")

    @machine_type.setter
    def machine_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "machine_type", value)

    @property
    @pulumi.getter(name="memorySizeMib")
    def memory_size_mib(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "memory_size_mib")

    @memory_size_mib.setter
    def memory_size_mib(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "memory_size_mib", value)

    @property
    @pulumi.getter
    def metadata(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "metadata")

    @metadata.setter
    def metadata(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "metadata", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="ngtCredentials")
    def ngt_credentials(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        return pulumi.get(self, "ngt_credentials")

    @ngt_credentials.setter
    def ngt_credentials(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "ngt_credentials", value)

    @property
    @pulumi.getter(name="ngtEnabledCapabilityLists")
    def ngt_enabled_capability_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Application names that are enabled.
        * `num_vcpus_per_socket`: - (Optional) Number of vCPUs per socket.
        * `num_sockets`: - (Optional) Number of vCPU sockets.
        * `gpu_list`: - (Optional) GPUs attached to the VM.
        * `parent_referece`: - (Optional) Reference to an entity that the VM cloned from.
        * `memory_size_mib`: - (Optional) Memory size in MiB.
        * `boot_device_order_list`: - (Optional) Indicates the order of device types in which VM should try to boot from. If boot device order is not provided the system will decide appropriate boot device order.
        * `boot_device_disk_address`: - (Optional) Address of disk to boot from.
        * `boot_device_mac_address`: - (Optional) MAC address of nic to boot from.
        * `boot_type`: - (Optional) Indicates whether the VM should use Secure boot, UEFI boot or Legacy boot.If UEFI or; Secure boot is enabled then other legacy boot options (like boot_device and; boot_device_order_list) are ignored. Secure boot depends on UEFI boot, i.e. enabling; Secure boot means that UEFI boot is also enabled. The possible value are: UEFI", "LEGACY", "SECURE_BOOT".
        * `machine_type`: - Machine type for the VM. Machine type Q35 is required for secure boot and does not support IDE disks.
        * `hardware_clock_timezone`: - (Optional) VM's hardware clock timezone in IANA TZDB format (America/Los_Angeles).
        * `guest_customization_cloud_init_user_data`: - (Optional) The contents of the user_data configuration for cloud-init. This can be formatted as YAML, JSON, or could be a shell script. The value must be base64 encoded.
        """
        return pulumi.get(self, "ngt_enabled_capability_lists")

    @ngt_enabled_capability_lists.setter
    def ngt_enabled_capability_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "ngt_enabled_capability_lists", value)

    @property
    @pulumi.getter(name="nicListStatuses")
    def nic_list_statuses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineNicListStatusArgs']]]]:
        return pulumi.get(self, "nic_list_statuses")

    @nic_list_statuses.setter
    def nic_list_statuses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineNicListStatusArgs']]]]):
        pulumi.set(self, "nic_list_statuses", value)

    @property
    @pulumi.getter(name="nicLists")
    def nic_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineNicListArgs']]]]:
        return pulumi.get(self, "nic_lists")

    @nic_lists.setter
    def nic_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineNicListArgs']]]]):
        pulumi.set(self, "nic_lists", value)

    @property
    @pulumi.getter(name="numSockets")
    def num_sockets(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "num_sockets")

    @num_sockets.setter
    def num_sockets(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "num_sockets", value)

    @property
    @pulumi.getter(name="numVcpusPerSocket")
    def num_vcpus_per_socket(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "num_vcpus_per_socket")

    @num_vcpus_per_socket.setter
    def num_vcpus_per_socket(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "num_vcpus_per_socket", value)

    @property
    @pulumi.getter(name="numVnumaNodes")
    def num_vnuma_nodes(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "num_vnuma_nodes")

    @num_vnuma_nodes.setter
    def num_vnuma_nodes(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "num_vnuma_nodes", value)

    @property
    @pulumi.getter(name="nutanixGuestTools")
    def nutanix_guest_tools(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "nutanix_guest_tools")

    @nutanix_guest_tools.setter
    def nutanix_guest_tools(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "nutanix_guest_tools", value)

    @property
    @pulumi.getter(name="ownerReference")
    def owner_reference(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "owner_reference")

    @owner_reference.setter
    def owner_reference(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "owner_reference", value)

    @property
    @pulumi.getter(name="parentReference")
    def parent_reference(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "parent_reference")

    @parent_reference.setter
    def parent_reference(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "parent_reference", value)

    @property
    @pulumi.getter(name="powerState")
    def power_state(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "power_state")

    @power_state.setter
    def power_state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "power_state", value)

    @property
    @pulumi.getter(name="powerStateMechanism")
    def power_state_mechanism(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "power_state_mechanism")

    @power_state_mechanism.setter
    def power_state_mechanism(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "power_state_mechanism", value)

    @property
    @pulumi.getter(name="projectReference")
    def project_reference(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        return pulumi.get(self, "project_reference")

    @project_reference.setter
    def project_reference(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "project_reference", value)

    @property
    @pulumi.getter(name="serialPortLists")
    def serial_port_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineSerialPortListArgs']]]]:
        return pulumi.get(self, "serial_port_lists")

    @serial_port_lists.setter
    def serial_port_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VirtualMachineSerialPortListArgs']]]]):
        pulumi.set(self, "serial_port_lists", value)

    @property
    @pulumi.getter(name="shouldFailOnScriptFailure")
    def should_fail_on_script_failure(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "should_fail_on_script_failure")

    @should_fail_on_script_failure.setter
    def should_fail_on_script_failure(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "should_fail_on_script_failure", value)

    @property
    @pulumi.getter
    def state(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "state")

    @state.setter
    def state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "state", value)

    @property
    @pulumi.getter(name="useHotAdd")
    def use_hot_add(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "use_hot_add")

    @use_hot_add.setter
    def use_hot_add(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "use_hot_add", value)

    @property
    @pulumi.getter(name="vgaConsoleEnabled")
    def vga_console_enabled(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "vga_console_enabled")

    @vga_console_enabled.setter
    def vga_console_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "vga_console_enabled", value)


class VirtualMachine(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 availability_zone_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 boot_device_disk_address: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 boot_device_mac_address: Optional[pulumi.Input[str]] = None,
                 boot_device_order_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 boot_type: Optional[pulumi.Input[str]] = None,
                 categories: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineCategoryArgs']]]]] = None,
                 cloud_init_cdrom_uuid: Optional[pulumi.Input[str]] = None,
                 cluster_uuid: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 disk_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineDiskListArgs']]]]] = None,
                 enable_cpu_passthrough: Optional[pulumi.Input[bool]] = None,
                 enable_script_exec: Optional[pulumi.Input[bool]] = None,
                 gpu_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineGpuListArgs']]]]] = None,
                 guest_customization_cloud_init_custom_key_values: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 guest_customization_cloud_init_meta_data: Optional[pulumi.Input[str]] = None,
                 guest_customization_cloud_init_user_data: Optional[pulumi.Input[str]] = None,
                 guest_customization_is_overridable: Optional[pulumi.Input[bool]] = None,
                 guest_customization_sysprep: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 guest_customization_sysprep_custom_key_values: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 guest_os_id: Optional[pulumi.Input[str]] = None,
                 hardware_clock_timezone: Optional[pulumi.Input[str]] = None,
                 is_vcpu_hard_pinned: Optional[pulumi.Input[bool]] = None,
                 machine_type: Optional[pulumi.Input[str]] = None,
                 memory_size_mib: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 ngt_credentials: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 ngt_enabled_capability_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 nic_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineNicListArgs']]]]] = None,
                 num_sockets: Optional[pulumi.Input[int]] = None,
                 num_vcpus_per_socket: Optional[pulumi.Input[int]] = None,
                 num_vnuma_nodes: Optional[pulumi.Input[int]] = None,
                 nutanix_guest_tools: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 owner_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 parent_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 power_state_mechanism: Optional[pulumi.Input[str]] = None,
                 project_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 serial_port_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineSerialPortListArgs']]]]] = None,
                 should_fail_on_script_failure: Optional[pulumi.Input[bool]] = None,
                 use_hot_add: Optional[pulumi.Input[bool]] = None,
                 vga_console_enabled: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        """
        Provides a Nutanix Virtual Machine resource to Create a virtual machine.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_nutanix as nutanix

        clusters = nutanix.get_clusters()
        vm1 = nutanix.VirtualMachine("vm1",
            cluster_uuid=clusters.entities[0].metadata["uuid"],
            categories=[nutanix.VirtualMachineCategoryArgs(
                name="Environment",
                value="Staging",
            )],
            num_vcpus_per_socket=1,
            num_sockets=1,
            memory_size_mib=2048)
        ```
        ### With Storage Config
        ```python
        import pulumi
        import pulumi_nutanix as nutanix

        clusters = nutanix.get_clusters()
        vm = nutanix.VirtualMachine("vm",
            cluster_uuid=clusters.entities[0].metadata["uuid"],
            num_vcpus_per_socket=1,
            num_sockets=1,
            memory_size_mib=186,
            disk_lists=[nutanix.VirtualMachineDiskListArgs(
                disk_size_bytes=68157440,
                disk_size_mib=65,
                storage_config=nutanix.VirtualMachineDiskListStorageConfigArgs(
                    storage_container_references=[nutanix.VirtualMachineDiskListStorageConfigStorageContainerReferenceArgs(
                        kind="storage_container",
                        uuid="2bbe67bc-fd14-4637-8de1-6379257f4219",
                    )],
                ),
            )])
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineDiskListArgs']]]] disk_lists: Disks attached to the VM.
               * `use_hot_add`: - (Optional) Use Hot Add when modifying VM resources. Passing value false will result in VM reboots. Default value is `true`.
               * `num_threads_per_core`: - (Optional) Number of threads per core.
               * `enable_cpu_passthrough`: - (Optional) Add true to enable CPU passthrough.
               * `is_vcpu_hard_pinned`: - (Optional) Add true to enable CPU pinning.
        :param pulumi.Input[str] guest_customization_cloud_init_meta_data: The contents of the meta_data configuration for cloud-init. This can be formatted as YAML or JSON. The value must be base64 encoded.
               * `guest_customization_cloud_init_custom_key_values`: - (Optional) Generic key value pair used for custom attributes in cloud init.
               * `guest_customization_is_overridable`: - (Optional) Flag to allow override of customization by deployer.
               * `guest_customization_sysprep`: - (Optional) VM guests may be customized at boot time using one of several different methods. Currently, cloud-init w/ ConfigDriveV2 (for Linux VMs) and Sysprep (for Windows VMs) are supported. Only ONE OF sysprep or cloud_init should be provided. Note that guest customization can currently only be set during VM creation. Attempting to change it after creation will result in an error. Additional properties can be specified. For example - in the context of VM template creation if \"override_script\" is set to \"True\" then the deployer can upload their own custom script.
               * `guest_customization_sysrep_custom_key_values`: - (Optional) Generic key value pair used for custom attributes in sysrep.
               * `should_fail_on_script_failure`: - (Optional)  Extra configs related to power state transition. Indicates whether to abort ngt shutdown/reboot if script fails.
               * `enable_script_exec`: - (Optional) Extra configs related to power state transition. Indicates whether to execute set script before ngt shutdown/reboot.
               * `power_state_mechanism`: - (Optional) Indicates the mechanism guiding the VM power state transition. Currently used for the transition to \"OFF\" state. Power state mechanism (ACPI/GUEST/HARD).
               * `vga_console_enabled`: - (Optional) Indicates whether VGA console should be enabled or not.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ngt_enabled_capability_lists: Application names that are enabled.
               * `num_vcpus_per_socket`: - (Optional) Number of vCPUs per socket.
               * `num_sockets`: - (Optional) Number of vCPU sockets.
               * `gpu_list`: - (Optional) GPUs attached to the VM.
               * `parent_referece`: - (Optional) Reference to an entity that the VM cloned from.
               * `memory_size_mib`: - (Optional) Memory size in MiB.
               * `boot_device_order_list`: - (Optional) Indicates the order of device types in which VM should try to boot from. If boot device order is not provided the system will decide appropriate boot device order.
               * `boot_device_disk_address`: - (Optional) Address of disk to boot from.
               * `boot_device_mac_address`: - (Optional) MAC address of nic to boot from.
               * `boot_type`: - (Optional) Indicates whether the VM should use Secure boot, UEFI boot or Legacy boot.If UEFI or; Secure boot is enabled then other legacy boot options (like boot_device and; boot_device_order_list) are ignored. Secure boot depends on UEFI boot, i.e. enabling; Secure boot means that UEFI boot is also enabled. The possible value are: UEFI", "LEGACY", "SECURE_BOOT".
               * `machine_type`: - Machine type for the VM. Machine type Q35 is required for secure boot and does not support IDE disks.
               * `hardware_clock_timezone`: - (Optional) VM's hardware clock timezone in IANA TZDB format (America/Los_Angeles).
               * `guest_customization_cloud_init_user_data`: - (Optional) The contents of the user_data configuration for cloud-init. This can be formatted as YAML, JSON, or could be a shell script. The value must be base64 encoded.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: VirtualMachineArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a Nutanix Virtual Machine resource to Create a virtual machine.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_nutanix as nutanix

        clusters = nutanix.get_clusters()
        vm1 = nutanix.VirtualMachine("vm1",
            cluster_uuid=clusters.entities[0].metadata["uuid"],
            categories=[nutanix.VirtualMachineCategoryArgs(
                name="Environment",
                value="Staging",
            )],
            num_vcpus_per_socket=1,
            num_sockets=1,
            memory_size_mib=2048)
        ```
        ### With Storage Config
        ```python
        import pulumi
        import pulumi_nutanix as nutanix

        clusters = nutanix.get_clusters()
        vm = nutanix.VirtualMachine("vm",
            cluster_uuid=clusters.entities[0].metadata["uuid"],
            num_vcpus_per_socket=1,
            num_sockets=1,
            memory_size_mib=186,
            disk_lists=[nutanix.VirtualMachineDiskListArgs(
                disk_size_bytes=68157440,
                disk_size_mib=65,
                storage_config=nutanix.VirtualMachineDiskListStorageConfigArgs(
                    storage_container_references=[nutanix.VirtualMachineDiskListStorageConfigStorageContainerReferenceArgs(
                        kind="storage_container",
                        uuid="2bbe67bc-fd14-4637-8de1-6379257f4219",
                    )],
                ),
            )])
        ```

        :param str resource_name: The name of the resource.
        :param VirtualMachineArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(VirtualMachineArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 availability_zone_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 boot_device_disk_address: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 boot_device_mac_address: Optional[pulumi.Input[str]] = None,
                 boot_device_order_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 boot_type: Optional[pulumi.Input[str]] = None,
                 categories: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineCategoryArgs']]]]] = None,
                 cloud_init_cdrom_uuid: Optional[pulumi.Input[str]] = None,
                 cluster_uuid: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 disk_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineDiskListArgs']]]]] = None,
                 enable_cpu_passthrough: Optional[pulumi.Input[bool]] = None,
                 enable_script_exec: Optional[pulumi.Input[bool]] = None,
                 gpu_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineGpuListArgs']]]]] = None,
                 guest_customization_cloud_init_custom_key_values: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 guest_customization_cloud_init_meta_data: Optional[pulumi.Input[str]] = None,
                 guest_customization_cloud_init_user_data: Optional[pulumi.Input[str]] = None,
                 guest_customization_is_overridable: Optional[pulumi.Input[bool]] = None,
                 guest_customization_sysprep: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 guest_customization_sysprep_custom_key_values: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 guest_os_id: Optional[pulumi.Input[str]] = None,
                 hardware_clock_timezone: Optional[pulumi.Input[str]] = None,
                 is_vcpu_hard_pinned: Optional[pulumi.Input[bool]] = None,
                 machine_type: Optional[pulumi.Input[str]] = None,
                 memory_size_mib: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 ngt_credentials: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 ngt_enabled_capability_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 nic_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineNicListArgs']]]]] = None,
                 num_sockets: Optional[pulumi.Input[int]] = None,
                 num_vcpus_per_socket: Optional[pulumi.Input[int]] = None,
                 num_vnuma_nodes: Optional[pulumi.Input[int]] = None,
                 nutanix_guest_tools: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 owner_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 parent_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 power_state_mechanism: Optional[pulumi.Input[str]] = None,
                 project_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 serial_port_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineSerialPortListArgs']]]]] = None,
                 should_fail_on_script_failure: Optional[pulumi.Input[bool]] = None,
                 use_hot_add: Optional[pulumi.Input[bool]] = None,
                 vga_console_enabled: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = VirtualMachineArgs.__new__(VirtualMachineArgs)

            __props__.__dict__["availability_zone_reference"] = availability_zone_reference
            __props__.__dict__["boot_device_disk_address"] = boot_device_disk_address
            __props__.__dict__["boot_device_mac_address"] = boot_device_mac_address
            __props__.__dict__["boot_device_order_lists"] = boot_device_order_lists
            __props__.__dict__["boot_type"] = boot_type
            __props__.__dict__["categories"] = categories
            __props__.__dict__["cloud_init_cdrom_uuid"] = cloud_init_cdrom_uuid
            if cluster_uuid is None and not opts.urn:
                raise TypeError("Missing required property 'cluster_uuid'")
            __props__.__dict__["cluster_uuid"] = cluster_uuid
            __props__.__dict__["description"] = description
            __props__.__dict__["disk_lists"] = disk_lists
            __props__.__dict__["enable_cpu_passthrough"] = enable_cpu_passthrough
            __props__.__dict__["enable_script_exec"] = enable_script_exec
            __props__.__dict__["gpu_lists"] = gpu_lists
            __props__.__dict__["guest_customization_cloud_init_custom_key_values"] = guest_customization_cloud_init_custom_key_values
            __props__.__dict__["guest_customization_cloud_init_meta_data"] = guest_customization_cloud_init_meta_data
            __props__.__dict__["guest_customization_cloud_init_user_data"] = guest_customization_cloud_init_user_data
            __props__.__dict__["guest_customization_is_overridable"] = guest_customization_is_overridable
            __props__.__dict__["guest_customization_sysprep"] = guest_customization_sysprep
            __props__.__dict__["guest_customization_sysprep_custom_key_values"] = guest_customization_sysprep_custom_key_values
            __props__.__dict__["guest_os_id"] = guest_os_id
            __props__.__dict__["hardware_clock_timezone"] = hardware_clock_timezone
            __props__.__dict__["is_vcpu_hard_pinned"] = is_vcpu_hard_pinned
            __props__.__dict__["machine_type"] = machine_type
            __props__.__dict__["memory_size_mib"] = memory_size_mib
            __props__.__dict__["name"] = name
            __props__.__dict__["ngt_credentials"] = ngt_credentials
            __props__.__dict__["ngt_enabled_capability_lists"] = ngt_enabled_capability_lists
            __props__.__dict__["nic_lists"] = nic_lists
            __props__.__dict__["num_sockets"] = num_sockets
            __props__.__dict__["num_vcpus_per_socket"] = num_vcpus_per_socket
            __props__.__dict__["num_vnuma_nodes"] = num_vnuma_nodes
            __props__.__dict__["nutanix_guest_tools"] = nutanix_guest_tools
            __props__.__dict__["owner_reference"] = owner_reference
            __props__.__dict__["parent_reference"] = parent_reference
            __props__.__dict__["power_state_mechanism"] = power_state_mechanism
            __props__.__dict__["project_reference"] = project_reference
            __props__.__dict__["serial_port_lists"] = serial_port_lists
            __props__.__dict__["should_fail_on_script_failure"] = should_fail_on_script_failure
            __props__.__dict__["use_hot_add"] = use_hot_add
            __props__.__dict__["vga_console_enabled"] = vga_console_enabled
            __props__.__dict__["api_version"] = None
            __props__.__dict__["cluster_name"] = None
            __props__.__dict__["host_reference"] = None
            __props__.__dict__["hypervisor_type"] = None
            __props__.__dict__["metadata"] = None
            __props__.__dict__["nic_list_statuses"] = None
            __props__.__dict__["power_state"] = None
            __props__.__dict__["state"] = None
        super(VirtualMachine, __self__).__init__(
            'nutanix:index/virtualMachine:VirtualMachine',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            api_version: Optional[pulumi.Input[str]] = None,
            availability_zone_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            boot_device_disk_address: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            boot_device_mac_address: Optional[pulumi.Input[str]] = None,
            boot_device_order_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            boot_type: Optional[pulumi.Input[str]] = None,
            categories: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineCategoryArgs']]]]] = None,
            cloud_init_cdrom_uuid: Optional[pulumi.Input[str]] = None,
            cluster_name: Optional[pulumi.Input[str]] = None,
            cluster_uuid: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            disk_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineDiskListArgs']]]]] = None,
            enable_cpu_passthrough: Optional[pulumi.Input[bool]] = None,
            enable_script_exec: Optional[pulumi.Input[bool]] = None,
            gpu_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineGpuListArgs']]]]] = None,
            guest_customization_cloud_init_custom_key_values: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            guest_customization_cloud_init_meta_data: Optional[pulumi.Input[str]] = None,
            guest_customization_cloud_init_user_data: Optional[pulumi.Input[str]] = None,
            guest_customization_is_overridable: Optional[pulumi.Input[bool]] = None,
            guest_customization_sysprep: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            guest_customization_sysprep_custom_key_values: Optional[pulumi.Input[Mapping[str, Any]]] = None,
            guest_os_id: Optional[pulumi.Input[str]] = None,
            hardware_clock_timezone: Optional[pulumi.Input[str]] = None,
            host_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            hypervisor_type: Optional[pulumi.Input[str]] = None,
            is_vcpu_hard_pinned: Optional[pulumi.Input[bool]] = None,
            machine_type: Optional[pulumi.Input[str]] = None,
            memory_size_mib: Optional[pulumi.Input[int]] = None,
            metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            ngt_credentials: Optional[pulumi.Input[Mapping[str, Any]]] = None,
            ngt_enabled_capability_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            nic_list_statuses: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineNicListStatusArgs']]]]] = None,
            nic_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineNicListArgs']]]]] = None,
            num_sockets: Optional[pulumi.Input[int]] = None,
            num_vcpus_per_socket: Optional[pulumi.Input[int]] = None,
            num_vnuma_nodes: Optional[pulumi.Input[int]] = None,
            nutanix_guest_tools: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            owner_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            parent_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            power_state: Optional[pulumi.Input[str]] = None,
            power_state_mechanism: Optional[pulumi.Input[str]] = None,
            project_reference: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            serial_port_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineSerialPortListArgs']]]]] = None,
            should_fail_on_script_failure: Optional[pulumi.Input[bool]] = None,
            state: Optional[pulumi.Input[str]] = None,
            use_hot_add: Optional[pulumi.Input[bool]] = None,
            vga_console_enabled: Optional[pulumi.Input[bool]] = None) -> 'VirtualMachine':
        """
        Get an existing VirtualMachine resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] api_version: The version of the API.
               * `state`: - The state of the vm.
               * `cluster_name`: - The name of the cluster.
               * `host_reference`: - Reference to a host.
               * `hypervisor_type`: - The hypervisor type for the hypervisor the VM is hosted on.
               * `nic_list_status`: - Status NICs attached to the VM.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['VirtualMachineDiskListArgs']]]] disk_lists: Disks attached to the VM.
               * `use_hot_add`: - (Optional) Use Hot Add when modifying VM resources. Passing value false will result in VM reboots. Default value is `true`.
               * `num_threads_per_core`: - (Optional) Number of threads per core.
               * `enable_cpu_passthrough`: - (Optional) Add true to enable CPU passthrough.
               * `is_vcpu_hard_pinned`: - (Optional) Add true to enable CPU pinning.
        :param pulumi.Input[str] guest_customization_cloud_init_meta_data: The contents of the meta_data configuration for cloud-init. This can be formatted as YAML or JSON. The value must be base64 encoded.
               * `guest_customization_cloud_init_custom_key_values`: - (Optional) Generic key value pair used for custom attributes in cloud init.
               * `guest_customization_is_overridable`: - (Optional) Flag to allow override of customization by deployer.
               * `guest_customization_sysprep`: - (Optional) VM guests may be customized at boot time using one of several different methods. Currently, cloud-init w/ ConfigDriveV2 (for Linux VMs) and Sysprep (for Windows VMs) are supported. Only ONE OF sysprep or cloud_init should be provided. Note that guest customization can currently only be set during VM creation. Attempting to change it after creation will result in an error. Additional properties can be specified. For example - in the context of VM template creation if \"override_script\" is set to \"True\" then the deployer can upload their own custom script.
               * `guest_customization_sysrep_custom_key_values`: - (Optional) Generic key value pair used for custom attributes in sysrep.
               * `should_fail_on_script_failure`: - (Optional)  Extra configs related to power state transition. Indicates whether to abort ngt shutdown/reboot if script fails.
               * `enable_script_exec`: - (Optional) Extra configs related to power state transition. Indicates whether to execute set script before ngt shutdown/reboot.
               * `power_state_mechanism`: - (Optional) Indicates the mechanism guiding the VM power state transition. Currently used for the transition to \"OFF\" state. Power state mechanism (ACPI/GUEST/HARD).
               * `vga_console_enabled`: - (Optional) Indicates whether VGA console should be enabled or not.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ngt_enabled_capability_lists: Application names that are enabled.
               * `num_vcpus_per_socket`: - (Optional) Number of vCPUs per socket.
               * `num_sockets`: - (Optional) Number of vCPU sockets.
               * `gpu_list`: - (Optional) GPUs attached to the VM.
               * `parent_referece`: - (Optional) Reference to an entity that the VM cloned from.
               * `memory_size_mib`: - (Optional) Memory size in MiB.
               * `boot_device_order_list`: - (Optional) Indicates the order of device types in which VM should try to boot from. If boot device order is not provided the system will decide appropriate boot device order.
               * `boot_device_disk_address`: - (Optional) Address of disk to boot from.
               * `boot_device_mac_address`: - (Optional) MAC address of nic to boot from.
               * `boot_type`: - (Optional) Indicates whether the VM should use Secure boot, UEFI boot or Legacy boot.If UEFI or; Secure boot is enabled then other legacy boot options (like boot_device and; boot_device_order_list) are ignored. Secure boot depends on UEFI boot, i.e. enabling; Secure boot means that UEFI boot is also enabled. The possible value are: UEFI", "LEGACY", "SECURE_BOOT".
               * `machine_type`: - Machine type for the VM. Machine type Q35 is required for secure boot and does not support IDE disks.
               * `hardware_clock_timezone`: - (Optional) VM's hardware clock timezone in IANA TZDB format (America/Los_Angeles).
               * `guest_customization_cloud_init_user_data`: - (Optional) The contents of the user_data configuration for cloud-init. This can be formatted as YAML, JSON, or could be a shell script. The value must be base64 encoded.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _VirtualMachineState.__new__(_VirtualMachineState)

        __props__.__dict__["api_version"] = api_version
        __props__.__dict__["availability_zone_reference"] = availability_zone_reference
        __props__.__dict__["boot_device_disk_address"] = boot_device_disk_address
        __props__.__dict__["boot_device_mac_address"] = boot_device_mac_address
        __props__.__dict__["boot_device_order_lists"] = boot_device_order_lists
        __props__.__dict__["boot_type"] = boot_type
        __props__.__dict__["categories"] = categories
        __props__.__dict__["cloud_init_cdrom_uuid"] = cloud_init_cdrom_uuid
        __props__.__dict__["cluster_name"] = cluster_name
        __props__.__dict__["cluster_uuid"] = cluster_uuid
        __props__.__dict__["description"] = description
        __props__.__dict__["disk_lists"] = disk_lists
        __props__.__dict__["enable_cpu_passthrough"] = enable_cpu_passthrough
        __props__.__dict__["enable_script_exec"] = enable_script_exec
        __props__.__dict__["gpu_lists"] = gpu_lists
        __props__.__dict__["guest_customization_cloud_init_custom_key_values"] = guest_customization_cloud_init_custom_key_values
        __props__.__dict__["guest_customization_cloud_init_meta_data"] = guest_customization_cloud_init_meta_data
        __props__.__dict__["guest_customization_cloud_init_user_data"] = guest_customization_cloud_init_user_data
        __props__.__dict__["guest_customization_is_overridable"] = guest_customization_is_overridable
        __props__.__dict__["guest_customization_sysprep"] = guest_customization_sysprep
        __props__.__dict__["guest_customization_sysprep_custom_key_values"] = guest_customization_sysprep_custom_key_values
        __props__.__dict__["guest_os_id"] = guest_os_id
        __props__.__dict__["hardware_clock_timezone"] = hardware_clock_timezone
        __props__.__dict__["host_reference"] = host_reference
        __props__.__dict__["hypervisor_type"] = hypervisor_type
        __props__.__dict__["is_vcpu_hard_pinned"] = is_vcpu_hard_pinned
        __props__.__dict__["machine_type"] = machine_type
        __props__.__dict__["memory_size_mib"] = memory_size_mib
        __props__.__dict__["metadata"] = metadata
        __props__.__dict__["name"] = name
        __props__.__dict__["ngt_credentials"] = ngt_credentials
        __props__.__dict__["ngt_enabled_capability_lists"] = ngt_enabled_capability_lists
        __props__.__dict__["nic_list_statuses"] = nic_list_statuses
        __props__.__dict__["nic_lists"] = nic_lists
        __props__.__dict__["num_sockets"] = num_sockets
        __props__.__dict__["num_vcpus_per_socket"] = num_vcpus_per_socket
        __props__.__dict__["num_vnuma_nodes"] = num_vnuma_nodes
        __props__.__dict__["nutanix_guest_tools"] = nutanix_guest_tools
        __props__.__dict__["owner_reference"] = owner_reference
        __props__.__dict__["parent_reference"] = parent_reference
        __props__.__dict__["power_state"] = power_state
        __props__.__dict__["power_state_mechanism"] = power_state_mechanism
        __props__.__dict__["project_reference"] = project_reference
        __props__.__dict__["serial_port_lists"] = serial_port_lists
        __props__.__dict__["should_fail_on_script_failure"] = should_fail_on_script_failure
        __props__.__dict__["state"] = state
        __props__.__dict__["use_hot_add"] = use_hot_add
        __props__.__dict__["vga_console_enabled"] = vga_console_enabled
        return VirtualMachine(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="apiVersion")
    def api_version(self) -> pulumi.Output[str]:
        """
        The version of the API.
        * `state`: - The state of the vm.
        * `cluster_name`: - The name of the cluster.
        * `host_reference`: - Reference to a host.
        * `hypervisor_type`: - The hypervisor type for the hypervisor the VM is hosted on.
        * `nic_list_status`: - Status NICs attached to the VM.
        """
        return pulumi.get(self, "api_version")

    @property
    @pulumi.getter(name="availabilityZoneReference")
    def availability_zone_reference(self) -> pulumi.Output[Mapping[str, str]]:
        return pulumi.get(self, "availability_zone_reference")

    @property
    @pulumi.getter(name="bootDeviceDiskAddress")
    def boot_device_disk_address(self) -> pulumi.Output[Mapping[str, str]]:
        return pulumi.get(self, "boot_device_disk_address")

    @property
    @pulumi.getter(name="bootDeviceMacAddress")
    def boot_device_mac_address(self) -> pulumi.Output[str]:
        return pulumi.get(self, "boot_device_mac_address")

    @property
    @pulumi.getter(name="bootDeviceOrderLists")
    def boot_device_order_lists(self) -> pulumi.Output[Sequence[str]]:
        return pulumi.get(self, "boot_device_order_lists")

    @property
    @pulumi.getter(name="bootType")
    def boot_type(self) -> pulumi.Output[str]:
        return pulumi.get(self, "boot_type")

    @property
    @pulumi.getter
    def categories(self) -> pulumi.Output[Sequence['outputs.VirtualMachineCategory']]:
        return pulumi.get(self, "categories")

    @property
    @pulumi.getter(name="cloudInitCdromUuid")
    def cloud_init_cdrom_uuid(self) -> pulumi.Output[str]:
        return pulumi.get(self, "cloud_init_cdrom_uuid")

    @property
    @pulumi.getter(name="clusterName")
    def cluster_name(self) -> pulumi.Output[str]:
        return pulumi.get(self, "cluster_name")

    @property
    @pulumi.getter(name="clusterUuid")
    def cluster_uuid(self) -> pulumi.Output[str]:
        return pulumi.get(self, "cluster_uuid")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[str]:
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="diskLists")
    def disk_lists(self) -> pulumi.Output[Sequence['outputs.VirtualMachineDiskList']]:
        """
        Disks attached to the VM.
        * `use_hot_add`: - (Optional) Use Hot Add when modifying VM resources. Passing value false will result in VM reboots. Default value is `true`.
        * `num_threads_per_core`: - (Optional) Number of threads per core.
        * `enable_cpu_passthrough`: - (Optional) Add true to enable CPU passthrough.
        * `is_vcpu_hard_pinned`: - (Optional) Add true to enable CPU pinning.
        """
        return pulumi.get(self, "disk_lists")

    @property
    @pulumi.getter(name="enableCpuPassthrough")
    def enable_cpu_passthrough(self) -> pulumi.Output[Optional[bool]]:
        return pulumi.get(self, "enable_cpu_passthrough")

    @property
    @pulumi.getter(name="enableScriptExec")
    def enable_script_exec(self) -> pulumi.Output[bool]:
        return pulumi.get(self, "enable_script_exec")

    @property
    @pulumi.getter(name="gpuLists")
    def gpu_lists(self) -> pulumi.Output[Sequence['outputs.VirtualMachineGpuList']]:
        return pulumi.get(self, "gpu_lists")

    @property
    @pulumi.getter(name="guestCustomizationCloudInitCustomKeyValues")
    def guest_customization_cloud_init_custom_key_values(self) -> pulumi.Output[Mapping[str, str]]:
        return pulumi.get(self, "guest_customization_cloud_init_custom_key_values")

    @property
    @pulumi.getter(name="guestCustomizationCloudInitMetaData")
    def guest_customization_cloud_init_meta_data(self) -> pulumi.Output[str]:
        """
        The contents of the meta_data configuration for cloud-init. This can be formatted as YAML or JSON. The value must be base64 encoded.
        * `guest_customization_cloud_init_custom_key_values`: - (Optional) Generic key value pair used for custom attributes in cloud init.
        * `guest_customization_is_overridable`: - (Optional) Flag to allow override of customization by deployer.
        * `guest_customization_sysprep`: - (Optional) VM guests may be customized at boot time using one of several different methods. Currently, cloud-init w/ ConfigDriveV2 (for Linux VMs) and Sysprep (for Windows VMs) are supported. Only ONE OF sysprep or cloud_init should be provided. Note that guest customization can currently only be set during VM creation. Attempting to change it after creation will result in an error. Additional properties can be specified. For example - in the context of VM template creation if \"override_script\" is set to \"True\" then the deployer can upload their own custom script.
        * `guest_customization_sysrep_custom_key_values`: - (Optional) Generic key value pair used for custom attributes in sysrep.
        * `should_fail_on_script_failure`: - (Optional)  Extra configs related to power state transition. Indicates whether to abort ngt shutdown/reboot if script fails.
        * `enable_script_exec`: - (Optional) Extra configs related to power state transition. Indicates whether to execute set script before ngt shutdown/reboot.
        * `power_state_mechanism`: - (Optional) Indicates the mechanism guiding the VM power state transition. Currently used for the transition to \"OFF\" state. Power state mechanism (ACPI/GUEST/HARD).
        * `vga_console_enabled`: - (Optional) Indicates whether VGA console should be enabled or not.
        """
        return pulumi.get(self, "guest_customization_cloud_init_meta_data")

    @property
    @pulumi.getter(name="guestCustomizationCloudInitUserData")
    def guest_customization_cloud_init_user_data(self) -> pulumi.Output[str]:
        return pulumi.get(self, "guest_customization_cloud_init_user_data")

    @property
    @pulumi.getter(name="guestCustomizationIsOverridable")
    def guest_customization_is_overridable(self) -> pulumi.Output[bool]:
        return pulumi.get(self, "guest_customization_is_overridable")

    @property
    @pulumi.getter(name="guestCustomizationSysprep")
    def guest_customization_sysprep(self) -> pulumi.Output[Mapping[str, str]]:
        return pulumi.get(self, "guest_customization_sysprep")

    @property
    @pulumi.getter(name="guestCustomizationSysprepCustomKeyValues")
    def guest_customization_sysprep_custom_key_values(self) -> pulumi.Output[Mapping[str, Any]]:
        return pulumi.get(self, "guest_customization_sysprep_custom_key_values")

    @property
    @pulumi.getter(name="guestOsId")
    def guest_os_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "guest_os_id")

    @property
    @pulumi.getter(name="hardwareClockTimezone")
    def hardware_clock_timezone(self) -> pulumi.Output[str]:
        return pulumi.get(self, "hardware_clock_timezone")

    @property
    @pulumi.getter(name="hostReference")
    def host_reference(self) -> pulumi.Output[Mapping[str, str]]:
        return pulumi.get(self, "host_reference")

    @property
    @pulumi.getter(name="hypervisorType")
    def hypervisor_type(self) -> pulumi.Output[str]:
        return pulumi.get(self, "hypervisor_type")

    @property
    @pulumi.getter(name="isVcpuHardPinned")
    def is_vcpu_hard_pinned(self) -> pulumi.Output[Optional[bool]]:
        return pulumi.get(self, "is_vcpu_hard_pinned")

    @property
    @pulumi.getter(name="machineType")
    def machine_type(self) -> pulumi.Output[str]:
        return pulumi.get(self, "machine_type")

    @property
    @pulumi.getter(name="memorySizeMib")
    def memory_size_mib(self) -> pulumi.Output[int]:
        return pulumi.get(self, "memory_size_mib")

    @property
    @pulumi.getter
    def metadata(self) -> pulumi.Output[Mapping[str, str]]:
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="ngtCredentials")
    def ngt_credentials(self) -> pulumi.Output[Mapping[str, Any]]:
        return pulumi.get(self, "ngt_credentials")

    @property
    @pulumi.getter(name="ngtEnabledCapabilityLists")
    def ngt_enabled_capability_lists(self) -> pulumi.Output[Sequence[str]]:
        """
        Application names that are enabled.
        * `num_vcpus_per_socket`: - (Optional) Number of vCPUs per socket.
        * `num_sockets`: - (Optional) Number of vCPU sockets.
        * `gpu_list`: - (Optional) GPUs attached to the VM.
        * `parent_referece`: - (Optional) Reference to an entity that the VM cloned from.
        * `memory_size_mib`: - (Optional) Memory size in MiB.
        * `boot_device_order_list`: - (Optional) Indicates the order of device types in which VM should try to boot from. If boot device order is not provided the system will decide appropriate boot device order.
        * `boot_device_disk_address`: - (Optional) Address of disk to boot from.
        * `boot_device_mac_address`: - (Optional) MAC address of nic to boot from.
        * `boot_type`: - (Optional) Indicates whether the VM should use Secure boot, UEFI boot or Legacy boot.If UEFI or; Secure boot is enabled then other legacy boot options (like boot_device and; boot_device_order_list) are ignored. Secure boot depends on UEFI boot, i.e. enabling; Secure boot means that UEFI boot is also enabled. The possible value are: UEFI", "LEGACY", "SECURE_BOOT".
        * `machine_type`: - Machine type for the VM. Machine type Q35 is required for secure boot and does not support IDE disks.
        * `hardware_clock_timezone`: - (Optional) VM's hardware clock timezone in IANA TZDB format (America/Los_Angeles).
        * `guest_customization_cloud_init_user_data`: - (Optional) The contents of the user_data configuration for cloud-init. This can be formatted as YAML, JSON, or could be a shell script. The value must be base64 encoded.
        """
        return pulumi.get(self, "ngt_enabled_capability_lists")

    @property
    @pulumi.getter(name="nicListStatuses")
    def nic_list_statuses(self) -> pulumi.Output[Sequence['outputs.VirtualMachineNicListStatus']]:
        return pulumi.get(self, "nic_list_statuses")

    @property
    @pulumi.getter(name="nicLists")
    def nic_lists(self) -> pulumi.Output[Sequence['outputs.VirtualMachineNicList']]:
        return pulumi.get(self, "nic_lists")

    @property
    @pulumi.getter(name="numSockets")
    def num_sockets(self) -> pulumi.Output[int]:
        return pulumi.get(self, "num_sockets")

    @property
    @pulumi.getter(name="numVcpusPerSocket")
    def num_vcpus_per_socket(self) -> pulumi.Output[int]:
        return pulumi.get(self, "num_vcpus_per_socket")

    @property
    @pulumi.getter(name="numVnumaNodes")
    def num_vnuma_nodes(self) -> pulumi.Output[int]:
        return pulumi.get(self, "num_vnuma_nodes")

    @property
    @pulumi.getter(name="nutanixGuestTools")
    def nutanix_guest_tools(self) -> pulumi.Output[Mapping[str, str]]:
        return pulumi.get(self, "nutanix_guest_tools")

    @property
    @pulumi.getter(name="ownerReference")
    def owner_reference(self) -> pulumi.Output[Mapping[str, str]]:
        return pulumi.get(self, "owner_reference")

    @property
    @pulumi.getter(name="parentReference")
    def parent_reference(self) -> pulumi.Output[Mapping[str, str]]:
        return pulumi.get(self, "parent_reference")

    @property
    @pulumi.getter(name="powerState")
    def power_state(self) -> pulumi.Output[str]:
        return pulumi.get(self, "power_state")

    @property
    @pulumi.getter(name="powerStateMechanism")
    def power_state_mechanism(self) -> pulumi.Output[str]:
        return pulumi.get(self, "power_state_mechanism")

    @property
    @pulumi.getter(name="projectReference")
    def project_reference(self) -> pulumi.Output[Mapping[str, str]]:
        return pulumi.get(self, "project_reference")

    @property
    @pulumi.getter(name="serialPortLists")
    def serial_port_lists(self) -> pulumi.Output[Optional[Sequence['outputs.VirtualMachineSerialPortList']]]:
        return pulumi.get(self, "serial_port_lists")

    @property
    @pulumi.getter(name="shouldFailOnScriptFailure")
    def should_fail_on_script_failure(self) -> pulumi.Output[bool]:
        return pulumi.get(self, "should_fail_on_script_failure")

    @property
    @pulumi.getter
    def state(self) -> pulumi.Output[str]:
        return pulumi.get(self, "state")

    @property
    @pulumi.getter(name="useHotAdd")
    def use_hot_add(self) -> pulumi.Output[Optional[bool]]:
        return pulumi.get(self, "use_hot_add")

    @property
    @pulumi.getter(name="vgaConsoleEnabled")
    def vga_console_enabled(self) -> pulumi.Output[bool]:
        return pulumi.get(self, "vga_console_enabled")

